NB. standard J profile
NB.
NB. 1. Definitions made here are required for the J development environment.
NB.
NB. 2. The following directory paths are defined (in SYSTEMFOLDERS_j_):
NB.    profile   - path to the profile file
NB.    system    - system files
NB.    temp      - temporary files
NB.    addons    - add on files
NB.    user      - user files
NB.    config    - user configuration path
NB.    home      - HOME in UNIX, otherwise same as profile
NB.
NB. 3. The boot process defines corresponding verbs that
NB.    prefix the directory name, and also ensure that
NB.    the path separator is correct, i.e. verbs:
NB.
NB.    jsystempath jtemppath, jaddonspath, juserpath, jconfigpath
NB.
NB.    boot also defines verb jcwdpath which points to the
NB.    current working directory.
NB.
NB.    For example, if the system directory is c:\j5 then:
NB.       jpath '~system\system/main/dates.ijs'
NB.    c:\j5\system\main\dates.ijs
NB.
NB. 4. To set up your own profile, for example to change the default
NB.    directory paths, first make a copy of this file, then change the
NB.    J startup parameter to point to the new file, e.g. under Windows:
NB.
NB.      c:\j5\j.exe -jprofile e:\jx\myprofile.ijs
NB.
NB. 5. You can add your own commands in the startup.ijs script,
NB.    see menu Edit|Configure|Startup in the J session.
NB.
NB. 6. JFE (J Front End) defines PROFILE_z_ as the full profile
NB.    filename, and defines ARGV_z_ as the command line args
NB.    a profile at that location can redefine PROFILE_z_ and load it

NB. =========================================================
NB. various global definitions
NB.
NB. Here, verb jhostpath converts between path separators / and \
NB. as required by the host system. For example, under Windows:
NB.       jhostpath 'system/main/dates.ijs'
NB.    system\main\dates.ijs
3 : 0 ''
notdef=. 0: ~: 4!:0 @ <
if. notdef 'ARGV' do. ARGV_z_=: ,<'undefined' end.
if. notdef 'PROFILE' do. PROFILE_z_=: 1!:45'' end.
PATHSEP_j_=: '/\'{~6=9!:12''
jhostpath_z_=: PATHSEP_j_ & ((# i.@#) @ (e.&'/\')@] })
''
)

NB. =========================================================
NB. create SYSTEMFOLDERS
NB. home entry is added in boot.ijs
sep=. PATHSEP_j_
prf=. PROFILE {.~ PROFILE i: sep
add=. prf,sep,'addons'
sys=. prf,sep,'system'
tmp=. (2!:5'HOME'),sep,'J/user'
usr=. (2!:5'HOME'),sep,'J/user'
cfg=. usr,sep,'config'
ids=. ;: 'profile system addons temp user config'
SYSTEMFOLDERS_j_=: ids ,. prf;sys;add;tmp;usr;cfg

NB. =========================================================
NB. boot up J:
0!:0 <jhostpath sys, '\extras\util\boot.ijs'
