NB. base plot class
NB. built from project: ~Classes\graphics\plot\plot
NB. initial definitions

script_z_ '~system\main\gl2.ijs'
script_z_ '~system\classes\plot\plotdefs.ijs'

coclass 'jzplot'


IFDEBUG=: 0
coextend 'jgl2'
LabTicMsg=: 'Number of labels and tic positions should be the same'
getxaxis=: 3 : 0
XStep=: {.XTIC

if. #XRANGE do.
  XMin=: {.XRANGE
  XMax=: 1{XRANGE,XMax
end.

if. #XINT do.
  XMin=: XMin <. XINT
  XMax=: XMax >. XINT
end.

if. #XLABEL do.
  if. #XTICPOS do.
    LabTicMsg assert (#XTICPOS)=#XLABEL
  else.
    XTICPOS=: dim0 XData
  end.
end.

if. #XTICPOS do.
  XMin=: XMin <. <./XTICPOS
  XMax=: XMax >. >./XTICPOS
end.
if. (<TYPE) e. BarTypes do.

  if. 0=#XLABEL do.
    if. #XTICPOS do.
      XLABEL=: ": each XTICPOS
    else.
      XLABEL=: ": each >:i.$XData
    end.
  end.

  if. #XTICPOS do.
    XMin=: XMin <. <./XTICPOS
    XMax=: XMax >. >./XTICPOS
  else.
    XTICPOS=: XMin + (XMax-XMin)*int01 <: #XData
  end.

  XDiv=: 0
  XINT=: XMin
else.

  if. #XTICPOS do.

    if. 0=#XINT do.
      XINT=: getint XTICPOS,XMin,XMax
    end.

  else.

    if. XMin=XMax do.
      ('XMin';'XMax')=: straddle XMin
    end.

    'XStep XINT XTICPOS'=: 'x' getticpos XINT;XTIC;XMin;XMax;XLOG
    XMin=: XMin <. <./XTICPOS
    XMax=: XMax >. >./XTICPOS
  end.

  XDiv=: zero (XINT-XMin)%XMax-XMin

end.

XDiff=: XMax-XMin
XTics=: 2}.fit01 XMin,XMax,XTICPOS
XRANGE=: XMin,XMax
)
getyaxis=: 3 : 0
YStep=: {.YTIC

if. #YRANGE do.
  YMin=: {.YRANGE
  YMax=: 1{YRANGE,YMax

end.

if. #YINT do.
  YMin=: YMin <. YINT
  YMax=: YMax >. YINT
end.

if. #YLABEL do.
  if. #YTICPOS do.
    LabTicMsg assert (#YTICPOS)=#YLABEL
  else.
    YTICPOS=: dim1 YData
  end.
end.

if. #YTICPOS do.
  YMin=: YMin <. <./YTICPOS
  YMax=: YMax >. >./YTICPOS
  if. 0=#YINT do.
    YINT=: getint YTICPOS,YMin,YMax
  end.

else.

  if. YMin=YMax do.
    ('YMin';'YMax')=: straddle YMin
  end.

  'YStep YINT YTICPOS'=: 'y' getticpos YINT;YTIC;YMin;YMax;YLOG
  YMin=: YMin <. <./YTICPOS
  YMax=: YMax >. >./YTICPOS
end.

YDiff=: YMax-YMin
YDiv=: zero (YINT-YMin)%YDiff
YTics=: 2}.fit01 YMin,YMax,YTICPOS
YRANGE=: YMin,YMax
)
getzaxis=: 3 : 0
ZStep=: {.ZTIC

if. #ZRANGE do.
  ZMin=: {.ZRANGE
  ZMax=: 1{ZRANGE,ZMax
end.

if. #ZINT do.
  ZMin=: ZMin <. ZINT
  ZMax=: ZMax >. ZINT
end.

if. #ZLABEL do.
  if. #ZTICPOS do.
    LabTicMsg assert (#ZTICPOS)=#ZLABEL
  else.
    n=. <./,ZData
    x=. >./,ZData
    ZTICPOS=: steps n,x, <:#ZLABEL
  end.
end.

if. #ZTICPOS do.
  ZMin=: ZMin <. <./ZTICPOS
  ZMax=: ZMax >. >./ZTICPOS
  if. 0=#ZINT do.
    ZINT=: getint ZTICPOS,ZMin,ZMax
  end.

else.

  if. ZMin=ZMax do.
    ('ZMin';'ZMax')=: straddle ZMin
  end.

  'ZStep ZINT ZTICPOS'=: 'z' getticpos ZINT;ZTIC;ZMin;ZMax;ZLOG
  ZMin=: ZMin <. <./ZTICPOS
  ZMax=: ZMax >. >./ZTICPOS
end.

ZDiff=: ZMax-ZMin
ZDiv=: (ZINT-ZMin)%ZDiff
ZTics=: 2}.fit01 ZMin,ZMax,ZTICPOS
ZRANGE=: ZMin,ZMax
)

LF=: 10{a.
CR=: 13{a.
EAV=: 255{a.
assert=: 0 0"_ $ 13!:8^:((0: e. ])`(12"_))
assign=: 4 : '".x.,''=:y.'''
bind=: 2 : 'x.@(y."_)'
blockcount=: [: {. }:@$ , 1:
boxopen=: <^:(L.=0:)
boxrows=: >@(,.&.>/)@:(;/&.>)
bx=: # i.@#
cile=: $@] $ ((* <.@:% #@]) /:@/:@,)
cleanz=: * | >: 1e_10"_
cross=: +/ .* (3 3 3$0 0 0 0 0 _1 0 1 0 0 0 1 0 0 0 _1 0 0 0 _1 0 1 0 0 0 0 0)&(+/ .*)
cut=: ' '&$: :([: -.&(<'') <;._2@,~)
cutxyz=: <"2@(0 1&|:)
deb=: #~ (+. 1: |. (> </\))@(' '&~:)
det=: -/ .*
dim0=: ]`({."1) @. (2:=#&$)
dim1=: ]`{. @. (2:=#&$)
dist=: +/&.(*:"_)
dlb=: }.~ =&' ' i. 0:
drange=: {:-{.
each=: &.>
extbmp=: , ((0: < #) *. [: -. '.'"_ e. ]) # '.bmp'"_
extwmf=: , ((0: < #) *. [: -. '.'"_ e. ]) # '.wmf'"_
fetch=: {::
first=: >@{.
firstin=: e. {.@# [
fit01=: ((- <./@,) % (>./ - <./)@,) : ((] - {.@[) % -~/@[)
fitin=: {.@[ + ({: - {.)@[ * ((- <./@,) % (>./ - <./)@,)@]
head=: {.~ i.&' '
fix=: _1&".
fmt=: ":@:<.@(0.5&+)
has=: [: +./ (e.~ boxopen f.)
index=: [ ((#@[ = ]) { ] , _1:) i.
int01=: i.@>: % ]
inxb=: <:@(+/\) i. i.@(+/)
ischar=: 2: = 3!:0
iscounter=: -: |@<.
isinteger=: -: <.
log10=: 10&^.
lsfit=: {:@] %. {.@] ^/ i.@>:@[
matsize=: _2: {. 1 1"_ , $
mp=: +/ . *
nc=: 4!:0
pfmt=: tominus@":
pick=: >@{
pickf=: 2 : 'u. @ > @ (n.&{)'
pow10=: 10&^
qt=: 2:+./\0:,2:|+/\@(=&'"')
splits=: i.&' ' ({.;}.@}.) ]
tomatrix=: (_2: {. 1 1"_ , $) $ ,
nthword=: +/\@(> 0: , }:)@(~:&' ')@] i. >:@[
partition=: 1: , [: -. }: -:"_1 }.
rank=: #@$
rank01=: 2: > [: # $
rfd=: *&1r180p1
rnd=: [ * [: <. 0.5"_ + %~
rndint=: <.@+&0.5
rnddn=: [ * [: <. %~
rndup=: [ * [: >. %~
signal=: 13!:8&12
sort=: $:~ : /:
split=: {. ; }.
tail=: }.~ >:@(i.&' ')
tominus=: '-'&((# i.@#)@(e.&'_')@]})
unitvec=: % dist


zero=: * | >: 1e_10"_

sin=: 1&o.
cos=: 2&o.
addwmfheader=: 3 : 0
({.y.)addwmfheader y.
:
a=. 16bd7 16bcd 16bc6 16b9a 0 0 0 0 0 0, 1 0 3 2{,256 256 #: >1{y.
a=. a,232 3 0 0 0 0
a=. a, ([: ~:/&.#: ,)"1 |: 10 2$a
a=. a{a.
(a,1!:1 {.y.) 1!:2 boxopen x.
)
boxarg=: 3 : 0
ws=. 8 9 10 13 32{a.
del=. 34 197 255{a.
dat=. ' ',y.
b=. (dat e. ws) > ~:/\ dat e. del
dat=. (<'') -.~ b <;._1 dat
dat -. each <del
)
boxcmd=: 3 : 0

if. 0 < L. y. do. y. else.
  y=. y.,';'
  b=. (y e. ';') > ~:/\ y e. '"'
  y=. b (<@dlb) ;._2 y
  y -. a:
end.
)
charsub=: 4 : 0
'f t'=. ((#x.)$0 1)<@,&a./.x.
t {~ f i. y.
)
chop=: 3 : 0
y. chop~ (' ',LF) {~ LF e. ,y.
:
if. 2>#$y.
do.
  (<'') -.~ (y e.x.) <;._2 y=. y.,{.x.
else.
  |: &.> y -. {: y=. (*./y e.x.) <;._2 |: y=. y.,"1 [ 2${.x.
end.
)
cutopen=: 3 : 0
y. cutopen~ (' ',LF) {~ LF e. ,y.
:
if. L. y. do. y. return. end.
if. 1 < #$y. do. <"_1 y. return. end.
(<'') -.~ (y e.x.) <;._2 y=. y.,{.x.
)
facenormal=: 4 : 0
norm=. x. * unitvec (}:cross&(-/)}.) 3{.y.
norm + (+/y.) % #y.
)
maxmask=: 4 : 0
rem=. y.-x.
if. 0 >: rem do. 1
elseif. rem <: x. do.
  1 ,~ (<:y.)$((rndint x.%rem)$1),0
elseif. 1 do.
  1 ,~ (<:y.)$1,(rndint rem%x.)$0
end.
)
mfv=: 4 : 0
if. 2>#$y. do.
  ];._2 y.,x. #~ x. ~: _1{.x.,y.
else.
  y.
end.
)
ncile=: 4 : 0
min=. <./,y.
max=. >./,y.
step=. }: min+(max-min)*(i.>:x.)%x.
<: +/ step <:/ y.
)
qchop=: 3 : 0
q=. qt y.
s=. ' '=y.
qs=. q*.s
y=. EAV (inxb qs)}y.
deb each unquot each ((EAV,' ')&charsub) each chop y
)

rndrect=: 3 : 0
shape=. $y.
'x y w h'=. |: _4 [\ ,y.
xw=. x+w
yh=. y+h
x=. rndint x
y=. rndint y
w=. (rndint xw) - x
h=. (rndint yh) - y
shape $ , |: x, y, w,: h
)
steps=: {. + (1&{ - {.) * (i.@>: % ])@{:
unquot=: 3 : 0
'" ' charsub y.
)
wdbuf=: 3 : 0
max=. 64000
buf=. y.
whilst. #buf do.
  if. max > #buf do. wd buf return.
  else.
    blk=. max {. buf
    ndx=. max - (|.blk) i. ';'
    wd ndx {. blk
    buf=. ndx }. buf
  end.
end.
)

plot_bar=: 3 : 0

plotinit''

float=. TYPE -: 'fbar'
stack=. TYPE -: 'sbar'

dat=. YData

cls=. {:$dat

if. float +. stack do.

  if. YLOG do.
    signal 'YLOG not valid with float or stack bars'
  end.

  pos=. makestackbar dat
  if. float do.
    pos=. cls}.pos
  end.
else.
  pos=. YDiv makebar dat
end.

pos=. (pos scalepos Vw,Vh) moverect Vx,Vy

'r c'=. $dat
dat=. ,dat

if. r=1 do.
  if. 1 e. 0 > dat do.
    setfx (ITEMCOLOR {~ dat < 0) drawrect pos
  else.
    setfx ({.ITEMCOLOR) drawrect pos
  end.
else.
  clr=. (r-float) $ ITEMCOLOR
  setfx clr drawrect (-c) ,\ pos
end.
)
makebar=: 4 : 0
dat=. ,y.
'r c'=. $y.
stp=. }: int01 c

if. r=1 do.
  x=. stp + %6*c
  w=. %1.5*c
else.
  x=. ,((6%8*r*c)*i.r) +/ stp+%8*c
  w=. %1.25*c*r
end.

if. x.=0 do.
  h=. (dat-YMin) % YMax-YMin
elseif. x.=1 do.
  h=. (dat-YMax) % YMax-YMin
elseif. 1 do.
  h=. dat % (YMax%1-x.) >. |YMin%x.
end.

int=. x.+h*h<0
x,.int,.w,.|h
)
makestackbar=: 3 : 0
dat=. ,y.
if. 1 e. 0 > dat do.
  signal 'stackbar values should not be negative'
end.
'r c'=. $y.
stp=. }: int01 c
w=. %1.5*c
h=. y.%YMax
int=. ,0,+/\}:h
x=. ,($int)$stp + %6*c
x,.int,.w,.,h
)

pd_cmd=: 3 : 0
cmd=. y.

if. cmd-:,<'state' do. wdview show_state'' return. end.

len=. #cmd
hdr=. head each cmd

hdr=. tolower@head each cmd
cmd=. hdr ([ , #@[ }. ] ) each cmd
if. len > ndx=. hdr i. <'reset' do.
  pd_reset 5}.ndx pick cmd
  pd_cmd (>:ndx)}.cmd
  return.
end.
if. len > ndx=. <./hdr i. ;:'form new use' do.
  PlotBuf=: PlotBuf,ndx{.cmd
  c=. ndx pick hdr
  f=. 'pd_',c
  f~ (#c) }. ndx pick cmd
  pd_cmd (>:ndx)}.cmd
  return.
end.
if. len > ndx=. hdr i.<'show' do.
  PlotBuf=: PlotBuf,ndx{.cmd
  pd_show''
  pd_cmd (>:ndx)}.cmd
  return.
end.
j=. ;:'clip print save savebmp'
if. 1 e. j e. hdr do.
  if. 0=#Plot do. pd_show'' end.
  ndx=. <./ hdr i. j
  PlotBuf=: PlotBuf,ndx{.cmd
  cmd=. ndx}.cmd
  hdr=. ndx}.hdr
  whilst. #hdr do.
    'fn arg'=. splits first cmd
    ('pd_',fn)~ arg
    ndx=. >: <./ (}.hdr) i. j
    cmd=. ndx}.cmd
    hdr=. ndx}.hdr
  end.
  return.
end.

PlotBuf=: PlotBuf,cmd
)
pd_clip=: 3 : 0
if. #y. do.
  wh=. 2$_1 ". y.
  if. _1 e. wh do.
    wdinfo 'clip';'Invalid size argument' return.
  end.
else.
  wh=. 10000 7500
end.
glfile ''
glsave 0,wh
)
pd_data=: 3 : 0
b=. ('type '&-:@(5&{.)) &> PlotBuf
if. 1 e. b do.
  CurType=: ({.~ i.&',') tolower deb 5}.>{:b#PlotBuf
  if. -. PlotTypes has CurType do.
    signal 'invalid type: ',CurType
  end.
end.
b=. ('polar '&-:@(6&{.)) &> PlotBuf
if. 1 e. b do.
  ndx=. b i: 1
  POLAR=: {. 1 ,~ fix 6}. ndx pick PlotBuf
  PlotBuf=: PlotBuf #~ -.b
end.

PlotCmds=: PlotCmds,<PlotBuf
PlotData=: PlotData,<getdata y.
PlotBuf=: ''

)
pd_exp=: 3 : 0
y=. y.
b=. y e. KEYWORDS
if. 1 e. b do.
  new=. boxcmd@".@toupper each b#y
  y=. <S:0 new (bx b) } y
end.
y
)
pd_form=: 3 : 0
y=. deb y.
h=. head y
if. #h do. PForm=: h end.
t=. tail y
if. #t do.
  p=. _1 ". t
  if. (4=#p) *. iscounter p do.
    PFormPos=: p
  else.
    signal 'Invalid form position: ',t
  end.
else.
  PFormPos=: ''
end.
Ndx=: 1
PHold=: 0
Plot=: i.0 0
PlotBuf=: PlotData=: PlotCmds=: ''
PReset=: 1
Pxywh=: ''
setuse ''
)
pd_new=: 3 : 0
plotmake''
setdefaults ".y.
Ndx=: Ndx+3
)
pd_print=: 3 : 0
if. IFJAVA do.
  wd 'psel ',":PFormhwnd
  glsel PId
  glzorientation ORIENTATION
  glzprintpage 'J Plot'
else.
  temp=. jpath '~temp\t1.wmf'
  glfile temp
  glsave 1 0 0
  wd 'pc print;cc g0 isigraph'
  glzcreate''
  glzstartdoc 'print'
  glzmap MM_TWIPS
  glzdevmode 'orientation 2'
  glzstartpage''
  size=. 1440 * %/ (2 3 ,: 4 5) { glqprinter''
  glplayxywh 0 0 ,size
  glplay temp
  glshow''
  glzprint''
  glzendpage''
  glzenddoc''
  wd 'pclose'
end.
)
pd_reset=: 3 : 0
pd_form y.
setdefaults''
)
pd_save=: 3 : 0

if. 0 e.#y. do. pd_clip'' return. end.

y=. qchop y.

if. -. (#y) e. 1 2 3 do.
  wdinfo 'save';'Too many arguments given' return.
end.

select. #y
case. 1 do.
  fn=. >{.y
  wh=. _2 {. 0 ". wd 'qchildxywhx ',PId
case. 2 do.
  pd_clip y. return.
case. 3 do.
  fn=. >{.y
  wh=. ; _1 ". each }. y
end.

if. _1 e. wh do.
  wdinfo 'save';'Invalid size argument' return.
end.

fn=. extwmf fn
1!:55 :: ] <fn

wd 'pc save'
wd 'xywh ',":0 0,wh
wd 'cc gsave isigraph rightmove bottommove; pas 0 0'
glmap MM_RAW
'gsave' plotshow''
glfile fn
glsave 0 0 0
wd 'pclose'
try.
  wd 'psel ',":PFormhwnd
  glsel PId
catch. end.
)
pd_savebmp=: 3 : 0
y=. qchop y.
fn=. ''
wh=. 512 512
select. #y
case. 1 do.
  fn=. >{.y
case. 2 do.
  wh=. 2 $ _1 ". >{: y
case. 3 do.
  fn=. >{.y
  wh=. ; _1 ". each }. y
end.

if. _1 e. wh do.
  wdinfo 'savebmp';'Invalid size argument' return.
end.

if. #fn do.
  fn=. extbmp fn
  1!:55 :: ] <fn
end.

wd 'pc save'
wd 'xywh ',":0 0 ,wh
wd 'cc gsavebmp isigraph rightmove bottommove; pas 0 0'
glmap MM_RAW
'gsavebmp' plotshow''
glfile fn
glsavebmp wh
wd 'pclose'
try.
  wd 'psel ',":PFormhwnd
  glsel PId
catch. end.
)
pd_show=: 3 : 0
plotmake''
Plot=: Plot /: {."1 Plot
popen''
pshow''
)
pd_text=: plot_text
pd_type=: 3 : 0
dat=. tolower y.
ndx=. dat i.' '
TYPE=: ndx{.dat
if. -. (<TYPE) e. PlotTypes do.
  signal 'unknown type: ',TYPE
end.
)
pd_use=: 3 : 0
plotmake''
setuse ".y.
Ndx=: Ndx+3
)

plot_contour=: 3 : 0

if. 2 ~: #$ZData do.
  signal 'need data matrix for contour plot'
  signal 'plot error'
end.

plotinit''

dat=. (#BANDCOLOR) ncile ZData

x=. sort (0 conpts dat),1 conpts dat
pos=. _2 ,\ 2}."1 x
pos=. pos-<./,pos
pos=. fitviewbox pos % >./,pos

setfx 0 0 0 drawline pos
)

xline=: 3 : 0
a=. }:y.
b=. }.y.
ip=. i.{:sp=. +/\p=. |v=. b-a
j=. ip + p # (v<0) - sp0=. 0,}:sp
r=. (p#a) + (p#*v) * j
l=. p # 60 % >:p
s=. l * ip - p # <:sp0
r,.s
)
conpts=: 4 : 0

if. x. do. m=. |:|.y. else. m=. y. end.

m=. (1,(2#~_2+#m),1)#m
a=. }:"1 m
b=. }."1 m
'r c'=. rc=. $a
v=. ,b-a
ip=. i. lp=. {:sp=. +/\ p=. |v
j=. ip + p # (v<0) - sp0=. 0,}:sp
s=. (p # ,a) + j * p # *v

l=. (ip - p # <:sp0) * p # 60 % >:p
t=. l + p#,rc$60*i.c

if. x. do.
  y=. p # c# 60*>.-:i.r
  n=. (,rc$p)# , ,.~ |:|.i.<:$y.
  n,.s,.y,.t
else.
  y=. p # c# 60*|.>.-:i.r
  n=. (,rc$p)# , ,.~ i.<:$y.
  n,.s,.t,.y
end.

)

plot_density=: 3 : 0

if. 2 ~: #$ZData do.
  signal 'need data matrix for density plot'
  signal 'plot error'
end.

plotinit''

j=. {(int01 #XData);int01 #YData
pos=. fitviewbox ,/ ,"2 tiles >j

j=. (#BANDCOLOR) ncile ,ZData
clr=. j { BANDCOLOR

if. MESH=0 do.
  size=. 0
  style=. 'null'
else.
  size=. 1
  style=. 0
end.

setfx 'poly';size;style;clr;EDGECOLOR;pos
)

Box3D=: _3[\,".;._2 (0 : 0)
0 0 0 0 0 1
0 0 0 0 1 0
0 0 0 1 0 0
0 0 1 0 1 1
0 0 1 1 0 1
0 1 0 0 1 1
0 1 0 1 1 0
1 0 0 1 0 1
1 0 0 1 1 0
0 1 1 1 1 1
1 0 1 1 1 1
1 1 0 1 1 1
)
drawarc=: 4 : 0
'arc';1;0;x.;0;y.
)
drawborder=: 3 : 0
if. BORDER do.
  setfx drawsbox PlotBox shrinkrect 2$BORDERSIZE
end. ''
)
drawcaptions=: 3 : 0
if. 0<#XCAPTION do.
  x=. Gx + -: Gw
  setfx 'textc';XCAPTION;CaptionFontSC;TEXTCOLOR;'';x,Cy+Py
end.

if. 0<#YCAPTION do.
  y=. Gy + -: Gh
  font=. CaptionFontSC,' angle900'
  if. IFDEBUG do.
    smoutput 'Cx,Px ',":Cx,Px
  end.
  setfx 'textc';YCAPTION;font;TEXTCOLOR;'';(Cx+Px),y
end.
)
drawdot=: 4 : 0
'dot';PENSIZE;0;x.;'';y.
)
drawellipse=: 4 : 0
'ellipse';PENSIZE;0;x.;EDGECOLOR;y.
)
drawgrafbox=: 3 : 0
setfx drawsbox GrafBox
if. FRAME *. YDiv e. 0 1 do. return. end.

if. (0 e. }.}:YTICPOS) + 3 <. #YTICPOS do.
  h=. Vy + Vh * (|{.YTICPOS) % ({: - {.) YTICPOS
  setfx GRIDCOLOR drawsline Gx,h,(Gx+Gw),h
end.
)
drawgrafbox3d=: 3 : 0
box=. (Box3D scalepos XYZDiff) movepos XYZMin
box=. project box
zbox=. {:"1 box
box=. }:"1 box
Box3DX=: /: _2 +/\ zbox 
j=. <Box3DX /: 3#1 0 0 1  
Box3DL=: j firstin &> 2 6 4 9 ;1 8 3 10 ;0 5 7 11
Min3D=: <./box
Max3D=: >./box
box=. ViewBox fitxy box
box=. 12 4$,box
box=. Box3DX{box
setfx FORECOLOR drawsline box
(>:Ndx) setfx FORECOLOR drawsline 3{.box
)
drawkey=: 3 : 0
if. 0=#KEY do. '' return. end.

len=. # &> KEY

if. {.KEYSTYLE do.
  xy=. |. Kx ,. Ky+KeyFontSZ*0.1+1.25*i.#KEY
  dat=. xy," 1 KeyFontSZ*1 0.7
  pos=. xy +"1 KeyFontSZ * 1.25 0.85
else.
  xy=. (Kx+KeyFontSZ * 0.5 * +/\ 0, 2.5+}:len) ,. Ky+KeyFontSZ*0.1
  dat=. xy," 1 KeyFontSZ*1 0.7
  pos=. xy +"1 KeyFontSZ * 1.25 0.85
end.

clr=. ITEMCOLOR $~ #KEY
setfx clr drawrect dat
setfx 'text';KEY;KeyFontSC;FORECOLOR;'';pos
)
drawkey=: 3 : 0

if. 0=#KEY do. '' return. end.

len=. # &> KEY
keyline=. <. {. KEYSTYLE % 2       
vtos=. 0, keyline * 0.35 * KeyFontSZ
keystyle=. 2 | KEYSTYLE             

if. {. keystyle do.
  xy=. |. Kx ,. Ky+KeyFontSZ*+0.1+1.25*i.#KEY
  dat=. (xy + vtos $~ $xy)," 1 KeyFontSZ*1 0.7
  pos=. xy +"1 KeyFontSZ * 1.25 0.85
else.
  xy=. (Kx+KeyFontSZ * 0.5 * +/\ 0, 2.5+}:len) ,. Ky+KeyFontSZ*0.1
  dat=. (xy + vtos $~ $xy)," 1 KeyFontSZ*1 0.7
  pos=. xy +"1 KeyFontSZ * 1.25 0.85
end.

clr=. ITEMCOLOR $~ #KEY
if. -. keyline do.
  setfx clr drawrect dat
else.
  sty=. PENSTYLE $~ #KEY          
  keylines=. 0 1 4 1 4 1{"1 dat,.((+/"1)0 2{"1 dat)
  setfx (sty;clr) drawlines keylines
end.
setfx 'text';KEY;KeyFontSC;FORECOLOR;'';pos
)
drawline=: 4 : 0
'line';PENSIZE;0;x.;'';y.
)
drawlines=: 4 : 0
'line';PENSIZE;x.,'';y.
)
drawpie=: 4 : 0
'pie';1;0;x.;EDGECOLOR;y.
)
drawpoly=: 4 : 0
'poly';PENSIZE;0;x.;EDGECOLOR;y.
)
drawrect=: 4 : 0
'rect';PENSIZE;0;x.;EDGECOLOR;y.
)
drawtitle=: 3 : 0
if. 0=#TITLE do. '' return. end.

y=. +/Py,Ph,--:TitleFontSZ*#TITLE
x=. Gx + -: Gw
setfx 'textc';TITLE;TitleFontSC;TEXTCOLOR;'';x,y
)
drawsbox=: 3 : 0
FORECOLOR drawsline ,makebox y.
)
drawslined=: 3 : 0
'lined';1;0;FORECOLOR;'';y.
)
drawsline=: 4 : 0
'line';1;0;x.;'';y.
)

plot_errorbar=: 3 : 0

'r c'=. $YData
'errorbar data should have 3 rows' assert r=3

plotinit''

dat=. GyDiv+(YData-YINT)*Vh%drange YTICPOS
'hi mid lo'=. dat

xpos=. Vx+Vw*}.int01 c

j=. ,./xpos,."1 [ hi ,: lo
k=. _3 0 3 0 +"1 ,.~ _2[\,j
errorbar=. j,k

errorbar=. 0>.PSize<.errorbar
clr=. {.ITEMCOLOR

setfx clr drawline errorbar
setfx clr drawline ,xpos,.mid
)

string=: a. & i.
count=: ,"1~ 1: + [: {: 1: , $

glbuf=: 3 : 'buf=:buf,,y.'

glbuf=: 3 : 0
buf=: buf,,y.
)

glx=: 11!:2999

glxarc=: 3 : 'buf=:buf,,count 2001,"1 y.'
glxbkmode=: 3 : 'buf=:buf,count 2003,,y.'
glxbrush=: 3 : 'buf=:buf,count 2004'
glxbrushnull=: 3 : 'buf=: buf, 2 2005'
glxclear=: 3 : 'buf=:buf,count 2007'
glxellipse=: 3 : 'buf=:buf,,count 2008,"1 y.'
glxfont=: 3 : 'buf=:buf,count 2012,string,y.'
glxlines=: 3 : 'buf=:buf,,count 2015,"1 y.'
glxmap=: 3 : 'buf=:buf,count 2016,,y.'
glxnoerasebkgnd=: 3 : 'buf=:buf,count 2071,,y.'
glxpen=: 3 : 'buf=:buf,count 2022,,y.'
glxpie=: 3 : 'buf=:buf,,count 2023,"1 y.'
glxpixel=: 3 : 'buf=:buf,,count 2024,"1 y.'
glxpolygon=: 3 : 'buf=:buf,,count 2029,"1 y.'
glxrect=: 3 : 'buf=:buf,,count 2031,"1 y.'
glxrgb=: 3 : 'buf=:buf,count 2032,,y.'
glxshow=: 3 : 'buf=:buf,2 2036'
glxtext=: 3 : 'buf=:buf,count 2038,string,y.'
glxtextalign=: 3 : 'buf=:buf,count 2039,,y.'
glxtextcolor=: 3 : 'buf=:buf,count 2040'
glxtextxy=: 3 : 'buf=:buf,count 2056,,y.'
glxwantresize=: 3 : 'buf=:buf,count 2068'
glxwindowext=: 3 : 'buf=:buf,count 2044,y.'

glnarc=: 2001
glnbkmode=: 2003
glnbrush=: 2004
glnbrushnull=: 2005
glnclear=: 2007
glnellipse=: 2008
glnfont=: 2012
glnlines=: 2015
glnpen=: 2022
glnpie=: 2023
glnpixel=: 2024
glnpolygon=: 2029
glnrect=: 2031
glnrgb=: 2032
glnshow=: 2036
glntext=: 2038
glntextalign=: 2039
glntextcolor=: 2040
glntextxy=: 2056
glnwantresize=: 2068

plot_hilo=: 3 : 0

plotinit''

'r c'=. $YData

ifclose=. 3=r

'hi lo close'=: 3$YData

dat=. GyDiv+(YData-YINT)*Vh%drange YTICPOS
clr=. 2$ITEMCOLOR

xpos=. Vx+Vw*}.int01 c
hilo=. ,./xpos,."1 [ 2{.dat
hilo=. 0>.PSize<.hilo
setfx ({.clr) drawline hilo
if. ifclose do.
  close=. ,xpos,.{:dat
  setfx ({:clr) drawline close
end.

)

Maximized=: 0
MaxAxisInt=: 0.9
MaxData=: 5000
PlotBuf=: PlotCmds=: PlotData=: ''
PForm=: 'plot'
PFormhwnd=: 0
PId=: 'gplot'
PInit=: 0   
PSize=: 1000
PlotBox=: 0 0,PSize,PSize
PTop=: 1
PHold=: 0
PShow=: 0        
Pxywh=: ''       
PStyle=: ''
TypeRest=: ''    
j=. ;: ;._2 (0 : 0)
area line
bar bar
dot point
errorbar errorbar
fbar bar
hilo hilo
line line
pie pie
poly poly
point point
radar radar
sbar bar
stick stick
)

PlotTypes2D=: {."1 j
PlotFns2D=: {:"1 j
j=. ;: ;._2 (0 : 0)
contour contour
density density
line line
poly poly
stick stick
surface surface
wire surface
)

PlotTypes3D=: {."1 j
PlotTypes3Def=: PlotTypes3D -. ;: 'line stick' 
PlotFns3D=: {:"1 j
j=. <;._2 (0 : 0)
linefit
)

PlotSpecial=: j

PlotTypes=: PlotTypes2D,PlotTypes3D
LineTypes=: ;:'dot errorbar line point poly radar stick'
BarTypes=: ;:'bar fbar sbar'
PieTypes=: ;:'pie'
opts=. ;: ;._2 (0 : 0)
ASPECT N
AXES V
BACKCOLOR X
BANDCOLOR Y
BORDER N
BORDERSIZE N
BOXED N
CAPTIONFONT C
CLEAR N
COLOR Y
EDGECOLOR X
ITEMCOLOR Y
FORECOLOR X
FRAME N
GRIDCOLOR X
GRIDS V
KEY B
KEYFONT C
KEYSTYLE V
LABELS V
LABELFONT C
MESH N
ORIENTATION N
PENSIZE N
PENSTYLE V
PLOTBOX V
PLOTCAPTION C
POLAR N
RTIC V
SEPARATOR C
SYMBOLFONT C
TEXTCOLOR X
TEXTFONT C
TICMAJOR N
TICMINOR N
TICS V
TITLE M
TITLEFONT C
TYPE C
VIEWCENTER V
VIEWPOINT V
VIEWSIZE V
VIEWUP V
VISIBLE N
XCAPTION C
XGRIDPATTERN V
XINT N
XLABEL A
XLOG N
XRANGE V
XTIC V
XTICPOS V
YCAPTION C
YGRIDPATTERN V
YINT N
YLABEL A
YLOG N
YRANGE V
YTIC V
YTICPOS V
ZGRIDPATTERN V
ZINT N
ZLABEL A
ZLOG N
ZRANGE V
ZTIC V
ZTICPOS V
)

DefOpts=: {."1 opts
DefOptx=: ,>{:"1 opts
setdefaults=: 3 : 0
plotdefault''
setuse y.
PInit=: 1
)
setuse=: 3 : 0
len=. #y.
if. len=0 do. PlotBox=: 0 0,PSize,PSize
elseif. len=4 do. PlotBox=: y.
elseif. 1 do. signal 'invalid parameter'
end.
'Px Py Pw Ph'=: PLOTBOX=: PlotBox
COLOR=: ''
KeyBox=: 0 0 0 0
KeyOff=: 0 0 0 0
CurType=: TYPE
FontScale=: (Pw+Ph+3*PSize)%5*PSize
Init=: 0
Data=: XData=: YData=: ZData=: ''
XMin=: YMin=: ZMin=: Min3D=: _
XMax=: YMax=: ZMax=: Max3D=: __
XDiv=: YDiv=: ZDiv=: 0
)
plotinit=: 3 : 0
if. -. 0 e. $COLOR do.
  if. (<TYPE) e. LineTypes, PieTypes do.
    ITEMCOLOR=: COLOR
  else.
    BANDCOLOR=: COLOR
  end.
  COLOR=: ''
end.

if. Init do. '' return. end.

if. CLEAR do.
  Plot=: Plot,(<:Ndx);0;'rect';1;0;BACKCOLOR;BACKCOLOR;PlotBox
end.

if. 0 e. $Data do. '' return. end.

AXES=: DIM$AXES
GRIDS=: DIM$GRIDS
KEYSTYLE=: 2 {. KEYSTYLE
LABELS=: DIM$LABELS
TICS=: DIM$TICS
XTIC=: XTIC,(#XTIC)}._1 _1
YTIC=: YTIC,(#YTIC)}._1 _1
ZTIC=: ZTIC,(#ZTIC)}._1 _1

CaptionFontSZ=: FontScale*getfontsize CAPTIONFONT
CaptionFontSC=: CaptionFontSZ setfontsize CAPTIONFONT
KeyFontSZ=: FontScale*getfontsize KEYFONT
KeyFontSC=: KeyFontSZ setfontsize KEYFONT
LabelFontSZ=: FontScale*getfontsize LABELFONT
LabelFontSC=: LabelFontSZ setfontsize LABELFONT
TitleFontSZ=: FontScale*getfontsize TITLEFONT
TitleFontSC=: TitleFontSZ setfontsize TITLEFONT

plotinittype''

Init=: 1
setbox ViewBox
)

plotinittype=: 3 : 0
select. TYPE
  
case. 'contour';'density' do.
  FRAME=: +./ AXES,FRAME
  
  getxaxis''
  getyaxis''
  getlogs''
  getlabels''
  getkeybox''
  getgrafbox''
  getview''
  drawtitle''
  drawborder''
  drawgrafbox''
  drawxgrid''
  drawygrid''
  drawxtics''
  drawytics''
  drawxlabs''
  drawylabs''
  return.
  
case. 'pie' do.
  FRAME=: 0
  getkeysize''
  getkeybox''
  getgrafpie''
  getview''
  drawtitle''
  drawborder''
  drawkey''
  return.
  
case. 'radar' do.
  FRAME=: 0
  getkeysize''
  getkeybox''
  getgrafpie''
  getview''
  drawtitle''
  drawborder''
  drawkey''
  return.
  
end.

if. DIM=2 do.
  getkeysize''
  getxaxis''
  getyaxis''
  getlogs''
  getlabels''
  getkeybox''
  getgrafbox''
  getview''
  drawtitle''
  drawcaptions''
  drawborder''
  drawxgrid''
  drawygrid''
  if. FRAME do.
    drawgrafbox''
  else.
    drawxaxis''
    drawyaxis''
  end.
  drawxtics''
  drawytics''
  drawxlabs''
  drawylabs''
  drawkey''
  
else.
  
  getkeysize''
  getxaxis''
  getyaxis''
  getzaxis''
  getlogs''
  getlabels''
  gettfm''
  getkeybox''
  getgrafbox''
  getview''
  
  drawtitle''
  drawborder''
  
  if. BOXED do.
    drawgrafbox3d ''
    drawxtics3d''
    drawytics3d''
    drawztics3d''
    drawxlabs3d''
    drawylabs3d''
    drawzlabs3d''
  end.
  
end.
)

plot_line=: 3 : 0

plotinit''
if. 1 e. MaxData < len=. {:$YData do.
  b=. MaxData maxmask len
  XData=: b # XData
  YData=: b #"1 YData
end.

if. TYPE -: 'area' do.
  if. 1 e. 0 > ,YData do.
    signal 'area plot y-values should not be negative'
  end.
  
  dat=. (YData-{.YMin)%YMax-YMin
  
  
  ndx=. 0
  xpos=. fit01 XData
  
  while. #dat do.
    pts=. fitviewbox xpos makearea {.dat
    setfx (ndx{ITEMCOLOR) drawpoly ,pts
    dat=. }.dat
    ndx=. (#ITEMCOLOR) | >:ndx
  end.
else.
  if. DIM=2 do.
    dat=. ,"2 (XDiv+(XData-XINT)%XDiff),."1 YDiv+(YData-YINT)%YDiff
    dat=. fitviewbox tomatrix dat
  else.
    dat=. 1 |: (XData ,: YData),"2 1 tomatrix ZData
    shape=. $dat
    dat=. shape $ , project ,/dat
    dat=. _2[\ ,}:"1 dat
    dat=. ViewBox fitxy dat
    dat=. (-+:1{shape) [\ ,dat
  end.
  clr=. ITEMCOLOR $~ #dat
  sty=. PENSTYLE $~ #dat
  setfx (sty;clr) drawlines dat
end.
)
makearea=: 4 : 0
x=. x.
dat=. x ,. y.
dat=. dat,1 0,0 0,:0,{.y.
)

plotcmd=: 3 : 0 L: 0
ndx=. y. i.' '
if. 0=ndx do. '' return. end.
cmd=. toupper ndx{.y.
arg=. (>:ndx)}.y.

select. cmd
case. 'TEXT' do. '' pd_text arg
case. 'TEXTC' do. 'c' pd_text arg
case. 'TEXTR' do. 'r' pd_text arg
case. 'TYPE' do. pd_type arg
case. do.
  
  ind=. DefOpts i. <cmd
  if. ind=#DefOpts do.
    signal 'option not found: ', cmd
  end.
  type=. ind{DefOptx
  select. type
  case. 'A' do.
    cmd assign boxarg arg
    type=. ind{DefOptx
  case. 'B' do.
    cmd assign boxarg arg
  case. 'C' do.
    cmd assign arg
  case. 'M' do.
    cmd assign SEPARATOR mfv arg
  case. 'N' do.
    cmd assign {. 1{. fix arg
  case. 'V' do.
    cmd assign fix arg
  case. 'X' do.
    cmd assign ".toupper arg
  case. 'Y' do.
    cmd assign _3[\,".toupper arg
  case. 1 do.
    signal 'plot option not supported'
  end.
end.
1
)
plotdata=: 3 : 0
if. 0=#y. do. plotinit'' return. end.
DIM=: #y.
log=. DIM{.XLOG,YLOG,ZLOG
Data=: log logcheck each numcheck each y.
if. 3=DIM do.
  
  'XData YData ZData'=: Data
  if. _1 < ndx=. PlotTypes3D index <TYPE do.
    ('plot_', ndx pick PlotFns3D)~0
  else.
    signal 'plot type not 3D'
  end.
  
elseif. 2=DIM do.
  'XData YData'=: Data
  
  if. _1 < ndx=. PlotTypes2D index <TYPE do.
    ('plot_', ndx pick PlotFns2D)~0
  else.
    signal 'plot type not 2D'
  end.
  
elseif. 1 do.
  signal 'invalid argument to plot'
  
end.
)
plotmake=: 3 : 0

if. #PlotBuf do.
  PlotCmds=: PlotCmds,<PlotBuf
  PlotData=: PlotData,<''
  PlotBuf=: ''
end.

if. 0=#PlotCmds do. '' return. end.
whilst. #PlotCmds do.
  
  cmd=. 0 pick PlotCmds
  data=. 0 pick PlotData
  
  PlotCmds=: }.PlotCmds
  PlotData=: }.PlotData
  
  
  tndx=. bx 'type '&-: @ (5&{.) &> cmd
  'should only be one type command per data set' assert 1 >: #tndx
  
  if. #tndx do.
    if. ',' e. tp=. ({.tndx) pick cmd do.
      tps=. 'type '&, each ',' cutopen 5}.tp
      cmd=. ({.tps) tndx} cmd
      while. #tps=. }.tps do.
        PlotCmds=: (< ({.tps) tndx} cmd), PlotCmds
        PlotData=: (< data), PlotData
      end.
    end.
  end.
  
  
  plotcmd cmd
  plotdata data
  
end.

PlotCmds=: PlotData=: ''
)
logcheck=: 4 : 0
if. x. do. if. 1 e. 0 >: ,y. do.
    signal 'Log argument to plot must be positive'
    signal 'plot error' end.
end.
y.
)

plot_pie=: 3 : 0
plotinit''
rect=. (Vx,Vy,Vw,Vh) scalerect 2%3
dat=. makepie ,YData
dat=. dat scalepos _2{.rect
dat=. dat movepie 2{.rect
clr=. ITEMCOLOR $~ #dat
setfx clr drawpie dat
)
makepie=: 3 : 0
rad=. 0.5p1 - 0,o.(%-:@{:)+/\y.
rad=. - 0,o.(%-:@{:)+/\y.
int=. +. 0.5 r. rad
_0.5 _0.5 1 1,"1 (}.,.}:) int
)

plotf=: 2 : 0
plot (;u.) steps 3{.n.,30
)

grays=: 3 : 0
3#"0 [ 255<. <. (256&% * i.@>:) y.
)
stellate=: 4 : 0 "2
norm=. x. * unitvec (}:cross&(-/)}.) 3{.y.
norm=. norm + (+/y.) % #y.
2 (norm&,)\y.,{.y.
)
surfacerev=: 10&$: : (4 : 0)
'r z'=. |: y.
ix=. i. x.+2
'x y'=. 0 1 |: r */ +. r. ix * 2p1%x.
x,"0 1 y,"0 z
)

selparent=: 1: @ wd @ ('psel '&, @ ":) :: 0:
pclose=: 3 : 0
try.
  wd 'psel ',PForm
  wd 'pclose'
catch. end.
)
popen=: 3 : 0
r=. popenme''
if. PShow=0 do.
  f=. PForm,'_',PId,'_size__COCREATOR'
  if. 0 > nc <f do.
    ". f,'=: pshow_',(>coname''),'_'
  end.
end.

glsel PId

r
)
popenme=: 3 : 0
if. selparent PFormhwnd do.
  wd 'pactive'
  glsel PId
  0 return.
end.
wd 'pc ',PForm
wd 'pn *',PLOTCAPTION

if. IFWINCE do.
  
  pos=. 0 0 200 150
  pos=. 0 0 180 110
  
else.
  if. 0=#PFormPos do.
    IfVGA=. 640 >:{.0".wd 'qm'
    pos=. 0 0,IfVGA{2 2$200 160 170 140
  else.
    pos=. 0 0,2}.PFormPos
  end.
end.

p=. ":4{.Pxywh,pos
wd 'xywh ',p
wd 'cc ',PId,' isigraph rightmove bottommove'
wd 'pas 0 0'

if. 0=wpset_j_ :: 0: PForm do. wdmove _1 0 end.

PFormhwnd=: wd 'qhwndp'

". PForm,'_close=: pclose'
". PForm,'_cancel=: pclose'
". PForm,'_',PId,'_size=: pshow'
". PForm,'_tctrl_fkey=: ptop'

PShow=: 1

)
pshow=: 3 : 0
first=. Pxywh -: ''
xywh=. 0 ". wd 'qchildxywhx ',PId
if. first >: xywh -: Pxywh do.
  plotshow''
end.
if. first *. PShow do.
  if. VISIBLE do.
    wd 'pshow ',Maximized#'sw_showmaximized'
  else.
    wd'pshow sw_hide'
  end.
  wd 'ptop ',":PTop
end.
if. xywh-:'' do.
  Pxywh=: 0 ". wd 'qchildxywhx ',PId
else.
  Pxywh=: xywh
end.

)
ptop=: 3 : 0
PTop=: -. PTop
wd 'ptop ',":PTop
)

plot_poly=: 3 : 0
plotinit''
if. DIM=2 do.
  
  dat=. ,"2 (XData-XINT),."1 YData-YINT
  dat=. dat scalepos (Vw%drange XRANGE),Vh%drange YRANGE
  dat=. dat movepos VxDiv,VyDiv
  dat=. 0>.PSize<.dat
  
else.
  
  dat=. XData ,"0 1 YData ,"0 ZData
  vert=. 1{$dat
  dat=. ($dat) $ , project ,/dat
  dat=. dat #~ facing dat
  
  dist=. {:"1 dat
  dat=. }:"1 dat
  
  near=. ~.(<.-:#,dist){.sort ,dist
  
  ndx=. /: +/"1 dist e. near
  dat=. ndx{dat
  dist=. ndx{dist
  
  ndx=. \:+/"1 dist
  dist=. ndx{dist
  dat=. ndx{dat
  
  dat=. ,/ dat
  dat=. ViewBox fitxy dat
  dat=. (-vert),\ dat
  
end.

clr=. ITEMCOLOR $~ blockcount dat
setfx clr drawpoly dat
)

plot_point=: 3 : 0

plotinit''
if. 1 e. MaxData < len=. {:$YData do.
  b=. MaxData maxmask len
  XData=: b # XData
  YData=: b #"1 YData
end.

if. DIM=2 do.
  dat=. ,"2 (XDiv+(XData-XINT)%XDiff),."1 YDiv+(YData-YINT)%YDiff
  dat=. fitviewbox tomatrix dat
  dat=. 0>.PSize<.dat
  
else.
  dat=. 1 |: (XData ,: YData),"2 1 ZData
  dat=. }:"1 project dat
  dat=. ,"2 dat
end.

rws=. #dat
cls=. {:$dat
clr=. ITEMCOLOR $~ #dat

rws=. 1

if. TYPE-:'dot' do.
  
  clr=. 0 0 0
  setfx clr drawdot dat
  
else.  
  
  size=. FontScale*getfontsize SYMBOLFONT
  
  
  if. 0 do.
    font=. size setfontsize SYMBOLFONT
    chr=. SYMBOLS
    dat=. PSize <. dat + ($dat)$0,size * 3r5
    while. 1 do.
      setfx 'textc';({.chr);font;({.clr);'';_2[\{.dat
      if. 0=#dat=. }.dat do. return. end.
      chr=. 1|.chr
      clr=. 1|.clr
    end.
    
  else.
    dat=. PSize <. dat
    while. 1 do.
      setfx 'circle';1;(size%3);({.clr);({.clr);_2[\{.dat
      if. 0=#dat=. }.dat do. return. end.
      clr=. 1|.clr
    end.
  end.
  
end.

)

plot_radar=: 3 : 0

plotinit''

RTIC=: 2{. RTIC,(#RTIC)}.3 1

if. {.AXES do.
  pts=. fitviewbox makeradaraxes YData
  setfx FORECOLOR drawline pts
end.

if. {.GRIDS do.
  pts=. makeradargrids YData
  pts=. pts scalepos Vw,Vh
  pts=. pts +"1 [ Vx,Vy,0 0
  setfx GRIDCOLOR drawarc pts ,"1 [ 1 1 1 1
end.

dat=. XData fit01"1 YData
pts=. fitviewbox makeradar dat
clr=. ITEMCOLOR $~ #pts
sty=. PENSTYLE $~ #pts
setfx (sty;clr) drawlines pts
)
makeradar=: 3 : 0
dat=. y. , {.y.
xy=. cleanz (sin ,. cos) +: o. int01 #y.
r=. ,"2 [ 0 1 |: xy */"1 dat
0.5 * 1 + r
)
makeradaraxes=: 3 : 0
if. {.TICS do.
  'maj min'=. RTIC
  len=. maj * >: min
  pos=. }.int01 len
  tic=. TICMINOR,(0={.GRIDS)*TICMAJOR
  mark=. len$(min,1)#500 %~ tic
  pts=. 0 0 0 1, 0 ,. pos ,. mark,. pos
else.
  pts=. ,:0 0 0 1
end.
f=. ((cos,sin),:-@sin,cos)"0
s=. f o. +: }:int01 #y.
pts=. ,/ ,"2 [ 1 |: s mp 0 1 |: _2 [\"1 pts
pts=. 0.5 * 1 + pts
)
makeradargrids=: 3 : 0
(,. -.@+:) ,.~ -: }: int01 {.RTIC
)

cube=: 3 : 0
v=. normalize 2 2 2#: i.8
ndx=. 0 2 6 4, 4 6 7 5, 1 5 7 3, 0 1 3 2, 2 3 7 6,: 0 4 5 1
ndx{v
)
dodecahedron=: 3 : 0
x=. 2 o. 1r5p1
y=. % <: +: x
a=. |: 2 1 o./ o. (+:i.5)%5
b=. |: 2 1 o./ o. (>:+:i.5)%5
v=. normalize (a,.0),((+:a*x),.1),((+:b*x),.y),b,.>:y
ndx=. 0 4 3 2 1, 0 1 6 10 5, 1 2 7 11 6, 2 3 8 12 7, 3 4 9 13 8
ndx=. ndx, 4 0 5 14 9, 5 10 15 19 14, 6 11 16 15 10, 7 12 17 16 11
ndx=. _5[\ ndx, 8 13 18 17 12, 9 14 19 18 13, 15 16 17 18 19
ndx{v
)
icosahedron=: 3 : 0
's c'=. 1 2 o. 1r5p1
x=. %: -. % 4 * *: s
y=. %: (1++:c) % 2++:c
a=. |: (2 1 o./ o. (+:i.5)%5) % +:s
b=. |: (2 1 o./ o. (>:+:i.5)%5) % +:s
v=. normalize 0,(a,.x),(b,.x+y),0 0,y++:x
ndx=. 0 2 1, 0 3 2, 0 4 3, 0 5 4, 0 1 5, 1 2 6, 2 3 7, 3 4 8
ndx=. ndx, 4 5 9, 5 1 10, 1 6 10, 2 7 6, 3 8 7, 4 9 8, 5 10 9
ndx=. _3[\ndx, 11 6 7, 11 7 8, 11 8 9, 11 9 10, 11 10 6
ndx{v
)
octahedron=: 3 : 0
v=. normalize 0 0 1, 1 0 0, 0 1 0, _1 0 0, 0 _1 0 ,: 0 0 _1
ndx=. 0 1 2, 0 2 3, 0 3 4, 0 4 1, 5 2 1, 5 3 2, 5 4 3,: 5 1 4
ndx{v
)
tetrahedron=: 3 : 0
r3=. -%%:3
r2=. %:2
r23=. %:2r3
v=. normalize (0,0,%:3), (0, (+:r23),r3), ((-r2),(-r23),r3),: r2,(-r23),r3
ndx=. 0 1 2, 0 2 3, 0 3 1,: 1 3 2
ndx{v
)
normalize=: 3 : 0
v=. (-"1 +/ % #) y.
clean v % >./ dist"1 v
)

plot_stick=: 3 : 0

if. DIM=3 do. conform3ds'' end.

plotinit''

if. DIM=2 do.
  dat=. ,"2 (XDiv+(XData-XINT)%XDiff),."1 YDiv+(YData-YINT)%YDiff
  dat=. fitviewbox tomatrix dat
  dat=. 0>.PSize<.dat
  dat=. _2 (4&$)\ ,dat
  dat=. (Vy+YDiv * Vh) 3}"1 dat
  dat=. rndint dat
  clr=. ITEMCOLOR $~ #dat
else.
  dat=. XData ,"0 1 YData ,"0 ZData
  minz=. ZINT <. <./ , {:"1 dat
  bas=. minz 2}"1 dat
  dat=. bas ,"1 dat
  dat=. ,/ _3 [\"1 dat
  dat=. project ,/dat
  dat=. ViewBox fitxy }:"1 dat
  dat=. _2 ,\ dat
  clr=. {.ITEMCOLOR
end.
setfx clr drawline dat
)

plotshow=: 3 : 0
PId plotshow y.
:
BUF=: buf=: ''
glxclear''
glxmap MM_RIGHTDOWN
glxnoerasebkgnd 1

if. IFDEBUG do. smoutput 'at plotshow' end.

dat=. y.
if. 0=#dat do. dat=. Plot end.

glsel x.
glxbkmode 1
glwindowext 1000 _1000
select. x.
case. 'gsave' do.
  scale=. PSize %~ _2 {. 0 ". wd 'qchildxywhx ',x.
  scale=. scale % >./scale
case. 'gsavebmp' do.
  scale=. PSize %~ _2 {. 0 ". wd 'qchildxywh ',x.
case. do.
  scale=. 1 1
end.

pos=. scalepos & scale

fonts=. ~. 4{"1 ((2{"1 Plot) e. 'text';'textc';'textr') # Plot
nfonts=. (-: +/scale) & fontscale each fonts
setfont=. glxfont @ (pick&nfonts) @ (fonts"_ i. <)

for_i. dat do.
  
  'n m t v s c e p'=. i
  
  select. t
    
  case. 'arc' do.
    
    p=. flipyarc p
    p=. rndint pos p
    
    glxrgb c
    glxpen v,s
    glxarc p
    
  case. 'box' do.
    
    p=. rndint pos p
    org=. 2{.p
    siz=. 2}.p
    
  case. 'dot' do.
    
    p=. flipypos p
    glxrgb 0 0 0
    glxpixel _2 [\ ,rndint pos p
    
  case. 'ellipse';'rect' do.
    
    glxrgb e
    glxpen v,s
    
    p=. flipyrect p
    p=. _4 [\ "1 rndrect pos p
    
    cmd=. ('gln',t)~
    glbuf (count glnrgb ,"1 c ) ,"1 (count glnbrush) ,"1 count cmd ,"1 p
    
  case. 'circle' do.
    glxrgb e
    glxpen 1,0
    glxbrush glxrgb c
    coffs=. s*|.scale%+/scale
    p=. p+($p)$_0.5 0.5*coffs
    p=. flipypos p
    p=. p,.((#p),2)$coffs
    p=. _4 [\ "1 rndint pos p
    p=. 0 0 2 2 >."1 p
    glxellipse p
    
  case. 'line' do.
    
    p=. flipypos p
    p=. rndint pos p
    
    if. (rank01 c) +. 1=#c do.
      
      glxrgb c
      glxpen v,0
      if. *./ s=0 do.
        glxlines p
      else.
        glxlines s ((pick&PENPATTERN)@[ linepattern ]) "0 1 p
      end.
      
    else.
      
      if. *./ s=0 do.
        glbuf (count glnrgb ,"1 c) ,"1 (count glnpen,v,0) ,"1 count glnlines ,"1 p
      else.
        for_i. i.#c do.
          glxrgb i { c
          glxpen v ,0
          glxlines ((i{s) pick PENPATTERN) linepattern i{p
        end.
      end.
      
    end.
    
  case. 'pie' do.
    
    p=. flipyarc p
    p=. rndint pos p
    
    glxrgb e
    glxpen v,s
    
    glbuf (count glnrgb ,"1 c) ,"1 (count glnbrush) ,"1 count glnpie ,"1 p
    
  case. 'poly' do.
    
    p=. flipypos p
    p=. rndint pos p
    rank1=. (rank01 c), rank01 e
    
    if. rank1 -: 1 1 do.
      
      glxrgb e
      glxpen v,s
      glxbrush glxrgb c
      glxpolygon p
      
    elseif. rank1 -: 0 1 do.
      
      glxrgb e
      glxpen v,s
      glbuf (count glnrgb ,"1 c) ,"1 (count glnbrush) ,"1 count glnpolygon ,"1 p
      
    elseif. rank1 -: 1 0 do.
      
      glxbrush glxrgb c
      glbuf (count glnrgb ,"1 e) ,"1 (count glnpen, v, s) ,"1 count glnpolygon ,"1 p
      
      
    elseif. 1 do.
      f=. count glnpolygon ,"1 p
      glbuf (count glnrgb ,"1 c) ,"1 ((count glnbrush) ,"1 count glnpen ,. v ,. s) ,"1 f
    end.
    
    
  case. 'text';'textc';'textr' do.
    
    p=. flipypos p
    p=. rndint pos p
    
    ndx=. (<t) i.~ 'text';'textc';'textr'
    glxtextalign ndx{TA_LEFT,TA_CENTER,TA_RIGHT
    
    if. rank01 c do.
      setfont s
      glxtextcolor glxrgb c
      if. rank01 p do.
        glxtextxy p
        glxtext ,>v
      else.
        v=. boxopen v
        b=. 0 < # &> v
        v=. b # v
        p=. b # p
        v=. count each glntext ,each string each v
        v=. (<"1 count glntextxy ,"1 p) ,each v
        glbuf ; v
      end.
    else.
      v=. boxopen v
      s=. boxopen s
      b=. 0 < # &> v
      v=. b # v
      p=. b # p
      c=. b # c
      s=. b # s
      v=. count each glntext ,each string each v
      v=. v ,each <"1 count glntextxy ,"1 p
      v=. (<"1 (count glnrgb ,"1 c) ,"1 count glntextcolor) ,each v
      w=. count each glnfont ,each string each s
      glbuf ; w ,each v
    end.
    
    glxtextalign TA_CENTER
    
  case. do.
    signal 'unrecognized Plot definition: ',":t
    
  end.
  
  11!:2999 buf
  BUF=: BUF,buf
  buf=: ''
  
end.

11!:2999 count glnshow

)

getdata=: 3 : 0
dat=. numcheck boxopen y.

if. POLAR=1 do.
  'data should have 2 items (r;theta)' assert 2=#dat
  'r t'=. dat
  'r and theta should have same shape' assert ($r) -: $t
  dat=. (r * sin t) ; r * cos t
end.

if. 1=#dat do.
  z=. tomatrix >dat
  select. CurType
  case. PlotTypes3Def do.
    dat=. (i.#z);(i.{:$z);z
  case. 'radar' do.
    z=. tomatrix z
    min=. 0 <. <./ , z
    max=. 1 >. >./ , z
    x=. (#z) $ 1 2$min,max
    dat=. x;z
  case. do.
    dat=. (i.{:$z);z
  end.
end.
'x y z'=. 3{.dat

XMin=: XMin <. <./,x
ZMin=: ZMin <. <./,z
XMax=: XMax >. >./,x
ZMax=: ZMax >. >./,z

if. (<CurType) e. 'bar' do.
  YMin=: YMin <. <./,y
  YMax=: YMax >. >./,y
  
elseif. (<CurType) e. 'fbar';'sbar' do.
  YMin=: YMin <. <./,y
  YMax=: YMax >. >./,+/y
  
elseif. 1 do.
  YMin=: YMin <. <./,y
  YMax=: YMax >. >./,y
end.

dat
)
getgrafbox=: 3 : 0

'x y w h'=. PLOTBOX
minw=. 0.075*w
minh=. 0.075*h
cleft=. 1.5 * CaptionFontSZ * 0<#YCAPTION
cbottom=. 1.5 * CaptionFontSZ * 0<#XCAPTION

mright=. minw
mtop=. minh + 2 * TitleFontSZ * #TITLE

mleft=. minw
mbottom=. minh

if. FRAME +. XDiv=0 do.
  mleft=. minw >. -: minw + 1.5*LabelFontSZ * >./#&>YLABEL
end.

if. FRAME +. YDiv=0 do.
  mbottom=. minh >. (-: minh) + 2 * LabelFontSZ
end.

mleft=. mleft + cleft
mbottom=. mbottom + cbottom

Cx=: -: minw
Cy=: cbottom + -: minh

j=. PLOTBOX+mleft,mbottom,-(mleft+mright),mbottom+mtop
GrafBox=: rndint j + KeyOff
'Gx Gy Gw Gh'=: GrafBox

if. FRAME do.
  GxDiv=: Gx
  GyDiv=: Gy
else.
  GxDiv=: Gx+Gw*XDiv
  GyDiv=: Gy+Gh*YDiv
end.
)
getgrafpie=: 3 : 0

'x y w h'=. PLOTBOX
minw=. 0.075*w
minh=. 0.075*h

mright=. minw
mtop=. minh + 2 * TitleFontSZ * #TITLE

mleft=. minw
mbottom=. minh

Gw=: w-mleft+mright
Gh=: h-mbottom+mtop

min=. Gh <. Gw%ASPECT
Gx=: x+mleft+0.5*Gw-min*ASPECT
Gy=: y+mbottom+0.5*Gh-min

GrafBox=: rndint Gx,Gy,(Gw=: min*ASPECT),Gh=: min
)
getkeybox=: 3 : 0

if. 0=#KEY do. KeyOff=: 4$0 return. end.

'x y w h'=. PLOTBOX

mw=. 0.025*w
mh=. 0.025*h

'typ pos'=. 2 {. KEYSTYLE
hz=. typ=0
vt=. typ=1

ow=. vt * Kw + +: mw
oh=. hz * Kh + +: mh
ox=. 0
oy=. 0

if. pos e. 0 3 do.
  Kx=: x + mw
  ox=. vt * Kx + Kw + mw
else.
  Kx=: (x+w) - Kw + mw
end.

if. pos e. 2 3 do.
  Ky=: y + mh
  oy=. hz * Ky + Kh + mh
else.
  Ky=: (y+h) - Kh + mh
end.

KeyBox=: Kx,Ky,Kw,Kh
KeyOff=: ox,oy,-ow,oh
)

getkeybox=: 3 : 0
if. 0=#KEY do. KeyOff=: 4$0 return. end.

'x y w h'=. PLOTBOX

mw=. 0.025*w
mh=. 0.025*h

'typ pos'=. 2 {. KEYSTYLE
hz=. 0=2|typ  
vt=. 1=2|typ  

ow=. vt * Kw + +: mw
oh=. hz * Kh + +: mh
ox=. 0
oy=. 0

if. pos e. 0 3 do.
  Kx=: x + mw
  ox=. vt * Kx + Kw + mw
else.
  Kx=: (x+w) - Kw + mw
end.

if. pos e. 2 3 do.
  Ky=: y + mh
  oy=. hz * Ky + Kh + mh
else.
  Ky=: (y+h) - Kh + mh
end.

KeyBox=: Kx,Ky,Kw,Kh
KeyOff=: ox,oy,-ow,oh
)

getkeysize=: 3 : 0
if. 0=#KEY do. '' return. end.
len=. # &> KEY
if. {.KEYSTYLE do.
  kw=. 1+0.5*>./len
  kh=. 0.8+1.25*<:#KEY
else.
  kw=. 1 + (1.25*<:#KEY) + 0.5*+/len
  kh=. 1
end.
box=. 0
Kw=: (box*10)+KeyFontSZ*kw
Kh=: (box*5)+KeyFontSZ*kh
)

getkeysize=: 3 : 0
if. 0=#KEY do. '' return. end.
len=. # &> KEY
if. 2|{.KEYSTYLE do.              
  kw=. 1+0.5*>./len
  kh=. 0.8+1.25*<:#KEY
else.
  kw=. 1 + (1.25*<:#KEY) + 0.5*+/len
  kh=. 1
end.
box=. 0
Kw=: (box*10)+KeyFontSZ*kw
Kh=: (box*5)+KeyFontSZ*kh
)
getint=: 3 : 0
min=. <./y.
max=. >./y.
if. max > 0 do. 0 >. min else. max end.
)
getlabels=: 3 : 0

if. 0=#XLABEL do.
  b=. (XINT=XTICPOS) *. (XINT=0) >: YDiv e. 0 1
  ndx=. bx (DIM=2) *. FRAME<b
  XLABEL=: (<'') ndx } pfmt each XTICPOS
end.

if. 0=#YLABEL do.
  b=. (YINT=YTICPOS) *. (YINT=0) >: XDiv e. 0 1
  ndx=. bx (DIM=2) *. FRAME<b
  YLABEL=: (<'') ndx } pfmt each YTICPOS
end.
if. 0=#ZLABEL do.
  b=. (ZINT=ZTICPOS) *. (ZINT=0) >: XDiv e. 0 1
  ndx=. bx (DIM=2) *. FRAME<b
  ZLABEL=: (<'') ndx } pfmt each ZTICPOS
end.
empty''
)
getlogs=: 3 : 0
if. XLOG do.
  XData=: log10 XData
  XINT=: log10 XINT
  XMax=: log10 XMax
  XMin=: log10 XMin
  XRANGE=: log10 XRANGE
  XDiff=: XMax-XMin
end.
if. YLOG do.
  YData=: log10 YData
  YINT=: log10 YINT
  YMax=: log10 YMax
  YMin=: log10 YMin
  YRANGE=: log10 YRANGE
  YDiff=: YMax-YMin
end.
if. ZLOG do.
  ZData=: log10 ZData
  ZINT=: log10 ZINT
  ZMax=: log10 ZMax
  ZMin=: log10 ZMin
  ZRANGE=: log10 ZRANGE
  ZDiff=: ZMax-ZMin
end.
1
)
getminor=: 4 : 0
if. x. > _1 do.
  max=. 3+'5' e. ": x.
  (1,max) {~ max <: <. 40 % #y.
else. 1 end.
)
gettfm=: 3 : 0
view=. VIEWPOINT-VIEWCENTER
ViewDist=: dist view
n=. view % ViewDist
v=. unitvec VIEWUP - n * n mp VIEWUP
t=. (v cross n),.v,.n
r=. -VIEWCENTER mp t
tfm=. (t,.0),r,1
XYZMin=: XMin,YMin,ZMin
XYZDiff=: (XMax,YMax,ZMax)-XYZMin
fitxyz=: [: movepos & XYZMin scalepos & XYZDiff
fit=. ((VIEWSIZE*=i.3)%XYZDiff),(-0.5+XYZMin%XYZDiff),1
Tfm=: fit mp tfm
)
getticpos=: 4 : 0

def=. (DIM=3){9 6

'int tic min max log'=. y.

step=. {.tic
wid=. max-min

if. wid=0 do.
  if. #int do.
    1;int;sort int,min
  else.
    1;min;,min
  end.
  return.
end.

if. log do.
  x. gettplog int;step;min;max;def return.
end.

t=. 0.5 1 2 5 10 20 * pow10 <: <. log10 wid
ndx=. +/ def < wid%t
assert ndx > 0

if. step <: 0 do.
  step=. ndx { t
end.

ifsame=. =/*min,max  
rnd=. (ndx-ifsame){t

if. max>0 do.
  min=. rnd rnddn min
  if. 0=#int do.
    int=. min * (min>0) *. (x.='x') +. wid<:-:max
  end.
  min=. int <. min
  pos=. min+step*i.>:>.(max-min)%step
else.
  if. 0=#int do.
    int=. rnd rndup max * (x.='x') +. wid<:-max
  end.
  len=. >:>.(int-min)%step
  pos=. int-step*i.-len
end.

step;int;pos
)
gettplog=: 4 : 0
'int step min max def'=. y.
max=. >.log10 max
min=. <.log10 min
step=. >.(max-min)%def
if. 0=#int do. int=. min
else. min=. min <. log10 int
end.
int=. pow10 int
pos=. pow10 min+step*i.>:>.(max-min)%step
step;int;pos
)
getview=: 3 : 0
if. FRAME do.
  ViewBox=: GrafBox shrinkrect 2*TICMAJOR*ASPECT,1
else.
  ViewBox=: GrafBox
end.
'Vx Vy Vw Vh'=: ViewBox
VxDiv=: Vx+Vw*XDiv
VyDiv=: Vy+Vh*YDiv
)
fitviewbox=: 3 : 0
(y. scalepos Vw,Vh) movepos Vx,Vy
)

plot_surface=: 3 : 0
conform3ds''

plotinit''
pos=. XData ,"0 1 YData ,"0 ZData
if. (TYPE-:'wire') *. PStyle has 'clear' do.
  pos=. pos,0 2 |: pos
  shape=. $pos
  pos=. shape $ ,project ,/ pos
  pos=. _2[\ ,}:"1 pos
  pos=. ViewBox fitxy pos
  pos=. (-+:1{shape) [\ ,pos
  setfx 'line';1;0;({.ITEMCOLOR);'';pos
  return.
end.
pos=. ($pos) $ ,project ,/ pos
zpos=. ,tilesum ZData
dpos=. ,tilesum {:"1 pos
ndx=. \:dpos
pos=. ,/,/ tiles }:"1 pos
pos=. ViewBox fitxy pos
pos=. _8[\,pos
pos=. ndx{pos

j=. ndx { (#BANDCOLOR) ncile zpos
clr=. j { BANDCOLOR

if. MESH=0 do.
  size=. 0
  style=. 5
else.
  size=. 1
  style=. 0
end.

if. TYPE-:'wire' do.
  setfx 'poly';1;0;BACKCOLOR;clr;pos
else.
  setfx 'poly';size;style;clr;EDGECOLOR;pos
end.

)
cfserr=: 3 : 0
signal 'need data matrix for surface plot'
signal 'plot error'
)
conform3ds=: 3 : 0
shp=. $ each XData;YData;ZData
if2=. 2 = # &> shp

select. +/if2
  
case. 0 do.
  XData=: ,:XData
  YData=: ,;YData
  ZData=: ,:ZData
  rxy=. $ZData
  
case. 1 do.
  
  rxy=. ;(-.if2)#shp
  rmat=. ;if2#shp
  
  if. -. rxy -: rmat do.
    if. rxy -: |.rmat do.
      nm=. (if2#'XYZ'),'Data'
      ".nm,'=:|:',nm
    else. cfserr'' end.
  end.
  
case. 2 do.
  rz=. ;(-.if2)#shp
  rs=. if2#shp
  rxy=. 0 pick rs
  if. (-:/rs) *: (rz e. rxy) do.
    cfserr''
  end.
  
case. 3 do.
  if. -. shp -: 3${.shp do.
    cfserr''
  end.
  rxy=. 0 pick shp
end.

'r c'=. rxy
if. 2>rank XData do.
  XData=: c#"1,.XData
end.
if. 2>rank YData do.
  YData=: rxy$YData
end.
if. 2>rank ZData do.
  ZData=: rxy$ZData
end.
)

plot_text=: 4 : 0
ndx=. 2 nthword y.
pos=. fix ndx{.y.
txt=. ndx}.y.

fn=. 'text',x.
pos=. (Px,Py)+pos*(Pw,Ph)%PSize
txt=. ':' mfv txt
'r c'=. $txt

size=. 25 >. FontScale*getfontsize TEXTFONT
font=. size setfontsize TEXTFONT
setfx fn;(,txt);font;TEXTCOLOR;'';pos
)

pd=: 3 : 0
buf=: ''
if. PInit=0 do. create'' end.
if. -. 0 e. $y. do.
  if. 2 e. 3!:0 S: 0 y. do.
    pd_cmd pd_exp boxcmd y.
  else.
    pd_data y.
  end.
end. empty''
)
plot=: 3 : 0
'' plot y.
:
opt=. x.
dat=. y.
if. dat-:'state' do.
  wdview show_state'' return.
end.


buf=: ''
if. #opt do.
  ndx=. opt i.';'
  first=. deb ndx{.opt
  ind=. <./ first i.', '
  if. (<ind {. first) e. PlotTypes,PlotSpecial do.
    opt=. 'type ',opt
  end.
end.
dat=. boxopen dat
if. 3=#dat do.
  b=. 3 < +/ rank &> dat
  opt=. ('type ',b pick 'line;';'surface;'),opt
end.

cmd=. boxcmd opt

if. 1 e. 'view3d' E. opt do.
  PForm=: 'v3d'
  pd 'reset;','view3d' delstring opt
  v3d_run VIEWDATA=: dat
else.
  
  
  if. -. PHold do. pd 'reset' end.
  
  PHold=: cmd has 'hold'
  cmd=. cmd -. <'hold'
  
  
  if. cmd has 'type linefit' do.
    pd 'type point;',cmd -. <'type linefit'
    pd 0 pick dat
    pd 'type line'
    pd 1 pick dat
  else.
    pd cmd
    pd dat
  end.
  
  if. -. PHold do. pd 'show' end.
  
end.

)

g0=. }:"1                            
g1=. (1 2&{ - 0 0&{)"2               
g2=. 0: < -/"1 @: ({. * |. @: {:)"2  
facing=: g2 @: g1 @: g0 f.
fitxy=: 4 : 0
'x y w h'=. x.
min=. Min3D <. <./y.
max=. Max3D >. >./y.
(x,y) +"1 (y. -"1 min)*"1 (w,h) % max-min
)
flipyarc=: 3 : 0
y=. _8[\,y.
c=. 1000 - (+/"1 [ 1 3{"1 y) ,. 5 7{"1 y
($y.) $ ,c 1 5 7}"1 y
)

flipypos=: ($ $ 0 1000"_) + ($ $ 1 _1"_) * ]

flipyrect=: 3 : 0
y=. _4[\,y.
c=. 1000 - +/"1 [ 1 3{"1 y
($y.) $ ,c 1}"0 1 y
)
fontscale=: ([ * getfontsize) setfontsize ]
getfontsize=: 13 : '{.1{._1 -.~ _1 ". y.'
linepattern1=: 4 : 0

len=. - -/ y.
n=. rndint (%: +/ *: len) % +/ x.
if. n=0 do. y.
else.
  j=. +/\ 0 , , n # ,: x.
  |: ({.y.) + len */ (}: % {:) j
end.
)
linepattern2=: 4 : 0
len=. - -/ y.
n=. rndint (%: +/ *: len) % +/ x.
if. n=0 do. y.
else.
  j=. +/\ 0 , , n # ,: x.
  |: ({.y.) + len */ (% {:) }: j
end.
)
linepattern=: 4 : 0
y=. _2 [\ y.
if. x. -: 1 0 do.
  2 ,\ y
else.
  a=. ; 2 < @ (x.&linepattern1) \ }: y
  _2 ,\ a , x. linepattern2 _2 {. y
end.
)
makebox=: 3 : 0
'x y h w'=. y.
xh=. x+h
yw=. y+w
5 2$x,y,xh,y,xh,yw,x,yw,x,y
)
movepos=: [ + $@[ $ ]
moverect=: 13 : 'x. + ($x.)$y.,0 0'
movepie=: 4 : 'x.+($x.)$xy,0 0,xy,xy=.y.-2$,x.'
numcheck=: 3 : 0
if. (ischar y.) +: 0 e. $y. do. y. return. end.
if. ischar y.
do. signal 'data should be numeric'
else. signal 'no data to plot'
end.
)
project=: 3 : 0
dat=. }:"1 (y.,.1) mp Tfm
dist=. ViewDist-{:"1 dat
((ViewDist*}:"1 dat)%dist),.dist
)
scalepos=: [ * $@[ $ ]
scalerect=: 4 : 0
new=. y. * old=. 2 3{x.
((2{.x.)+-:old-new),new
)
setbox=: 3 : 0
Plot=: Plot,Ndx;0;'box';'';'';BACKCOLOR;'';y.
)
setbrush=: [: ';grgb '&, ": , ';gbrush'"_
setfontsize=: 4 : 0
b=. ~: /\ y.='"'
nam=. b#y.
txt=. ;:(-.b)#y.
ndx=. 1 i.~ ([: *./ e.&'0123456789.') &> txt
nam, ; ,&' ' &.> (<fmt x.) ndx } txt
)
setfx=: 3 : 0
Ndx setfx y.
:
Plot=: Plot,x.;0;y.
)
setmv=: 3 : 0
Ndx setmv y.
:
Plot=: Plot,x.;1;y.
)
shownouns=: 3 : 0
rnd=. <.@+&0.5&.(%&0.0001)
cat=. ,&,.&.|:
x=. (>:>./# &> y.) {. each y.
f=. ]`rnd @. (e.&8 @ (3!:0))
y=. ":@f@". each y.
r=. x cat each y
> ,&.>/ r
)
show_state=: 3 : 0
ViewBox=: Vx,Vy,Vw,Vh
t=. ;:'PlotBox GrafBox ViewBox KeyBox'
shownouns t,DefOpts
)
shrinkrect=: + (,-@+:)
straddle=: 3 : 0
y.*1.5*(y.<0),y.>:0
)
c=. (}: ,:"1 }.)"2
d=. (}. ,:"1 }:)"2
tiles=: (c@}: ,"2 d@}.) f.
tilesum=: (1,:2 2)&(+/@,;._3)

drawxaxis=: 3 : 0

if. {.AXES do.
  setfx FORECOLOR drawsline (Gx-TICMAJOR*YINT=0),GyDiv,(Gx+Gw+TICMAJOR),GyDiv
end. ''
)
drawxgrid=: 3 : 0

if. 0={.GRIDS do. '' return. end.
y=. Vy+Vh*YTics
p=. Vx,.y,.(Vx+Vw),.y
setfx GRIDCOLOR drawsline p
)
drawxlabs=: 3 : 0

if. 0={.LABELS do. '' return. end.

if. (<TYPE) e. BarTypes do.
  xpos=. Vx+Vw*}: (0.5&% + int01) #XLABEL
  yint=. Gy-TICMAJOR
else.
  xpos=. Vx+Vw*XTics
  yint=. GyDiv + LabelFontSZ * (FRAME=0) *. YDiv >: MaxAxisInt
end.

pos=. xpos,.yint
setfx 'textc';XLABEL;LabelFontSC;FORECOLOR;'';pos
)
drawxlabs3d=: 3 : 0

if. 0={.LABELS do. '' return. end.
xpos=. XTics

ypos=. -3*TICMAJOR%PSize
ndx=. Box3DL firstin 2 6 4 9
if. ndx e. 6 9 do. ypos=. -<:ypos end.

pos=. xpos,"0 1 ypos,ndx e. 4 9
pos=. fitxyz pos
pos=. }:"1 project _3[\,pos
pos=. ViewBox fitxy pos

setfx 'textc';XLABEL;LabelFontSC;FORECOLOR;'';pos

)
drawxtics=: 3 : 0

if. 0={.TICS do. '' return. end.

if. (<TYPE) e. BarTypes do.
  step=. {:$YData
  xpos=. Vx+Vw*}: (0.5&% + int01) #XLABEL
  mark=. -step$TICMAJOR
  yint=. Gy
  
else.
  if. _1 = minor=. {:XTIC do.
    minor=. XStep getminor XTICPOS
  end.
  step=. >:(>:minor)*<:#XLABEL
  mark=. step$(1,minor)#TICMAJOR, TICMINOR
  mark=. mark * _1 ^ (FRAME=0) *. YDiv >: MaxAxisInt
  
  xpos=. Vx+Vw* (({.,}.)XTics) fitin int01 <: step
  yint=. GyDiv
end.

setfx FORECOLOR drawsline xpos,.yint,.xpos,.yint+mark

if. FRAME do.
  grint=. GyDiv+Gh
  setfx FORECOLOR drawsline xpos,.(grint-mark),.xpos,.grint
end.
)
drawxtics3d=: 3 : 0

if. 0={.TICS do. '' return. end.

if. _1 = minor=. {:XTIC do.
  minor=. XStep getminor XTICPOS
end.
step=. >:(>:minor)*<:#XLABEL

mark=. step$(1,minor)#(TICMAJOR,TICMINOR)%Vh>.Vw
xpos=. int01 <: step
ypos=. ,0,.mark
ndx=. Box3DL firstin 2 4 6 9
if. ndx e. 6 9 do. ypos=. -.ypos end.

pos=. (2#xpos),.ypos,.ndx e. 4 9
pos=. fitxyz pos
pos=. }:"1 project _3[\,pos
pos=. ViewBox fitxy pos
setfx FORECOLOR drawsline _4[\,pos
)

drawyaxis=: 3 : 0

if. 1{AXES do.
  tic=. ASPECT*TICMAJOR
  setfx FORECOLOR drawsline GxDiv,(Gy-tic*XINT=0),GxDiv,Gy+Gh+tic
end. ''
)
drawygrid=: 3 : 0

if. 0={:GRIDS do. '' return. end.
x=. Vx+Vw*XTics
p=. x,.Vy,.x,.Vy+Vh
setfx GRIDCOLOR drawsline p
)
drawylabs=: 3 : 0

if. 0=1{LABELS do. '' return. end.

ypos=. (Vy+Vh*int01 <:#YLABEL)+-:LabelFontSZ

if. XDiv < MaxAxisInt do.
  pos=. (GxDiv-ASPECT*TICMAJOR),.ypos
  setfx 'textr';YLABEL;LabelFontSC;FORECOLOR;'';pos
else.
  pos=. (GxDiv+ASPECT*TICMAJOR),.ypos
  setfx 'text';YLABEL;LabelFontSC;FORECOLOR;'';pos
end.
)
drawylabs3d=: 3 : 0

if. 0=1{LABELS do. '' return. end.

ypos=. YTics
xpos=. -3*TICMAJOR%PSize
ndx=. Box3DL firstin 1 8 3 10
if. ndx e. 8 10 do. xpos=. -<:xpos end.

pos=. xpos,.ypos,.ndx e. 3 10
pos=. fitxyz pos
pos=. }:"1 project _3[\,pos
pos=. ViewBox fitxy pos
setfx 'textc';YLABEL;LabelFontSC;FORECOLOR;'';pos
)
drawytics=: 3 : 0

if. 0=1{TICS do. '' return. end.

if. _1 = minor=. {:YTIC do.
  minor=. YStep getminor YTICPOS
end.

step=. >:(>:minor)*<:#YLABEL
mark=. step$(1,minor)#ASPECT*TICMAJOR,TICMINOR
mark=. mark*_1^XDiv >: MaxAxisInt
ypos=. Vy+Vh*int01 <: step
setfx FORECOLOR drawsline GxDiv,.ypos,.(GxDiv+mark),.ypos

if. FRAME do.
  grint=. GxDiv+Gw
  setfx FORECOLOR drawsline (grint-mark),.ypos,.grint,.ypos
end.
)
drawytics3d=: 3 : 0

if. 0=1{TICS do. '' return. end.

if. _1 = minor=. {:YTIC do.
  minor=. YStep getminor YTICPOS
end.

step=. >:(>:minor)*<:#YLABEL
mark=. step$(1,minor)#(TICMAJOR,TICMINOR)%Vh>.Vw
ypos=. int01 <: step
xpos=. ,0,.mark
ndx=. Box3DL firstin 1 8 3 10
if. ndx e. 8 10 do. xpos=. -.xpos end.

pos=. (xpos),.(2#ypos),.ndx e. 3 10
pos=. fitxyz pos
pos=. }:"1 project _3[\,pos
pos=. ViewBox fitxy pos
setfx FORECOLOR drawsline _4[\,pos
)

drawzlabs3d=: 3 : 0

if. 0=2{LABELS do. '' return. end.

zpos=. ZTics
xpos=. -3*TICMAJOR%PSize
ndx=. Box3DL firstin 0 5 7 11
if. ndx e. 7 11 do. xpos=. -<:xpos end.

pos=. xpos,.(ndx e. 5 11),.zpos

pos=. fitxyz pos
pos=. }:"1 project _3[\,pos
pos=. ViewBox fitxy pos
setfx 'textr';ZLABEL;LabelFontSC;FORECOLOR;'';pos
)
drawztics3d=: 3 : 0

if. 0=2{TICS do. '' return. end.

if. _1 = minor=. {:ZTIC do.
  minor=. ZStep getminor ZTICPOS
end.

step=. >:(>:minor)*<:#ZLABEL
mark=. step$(1,minor)#(TICMAJOR,TICMINOR)%Vh>.Vw

zpos=. int01 <: step
xpos=. ,0,.mark
ndx=. Box3DL firstin 0 5 7 11
if. ndx e. 7 11 do. xpos=. -. xpos end.

pos=. xpos,.(ndx e. 5 11),.2#zpos
pos=. fitxyz pos
pos=. }:"1 project _3[\,pos
pos=. ViewBox fitxy pos
setfx FORECOLOR drawsline _4[\,pos
)

create=: pd_reset
destroy=: codestroy