NB. plot defaults
NB.
NB. Note: names for global nouns defined in this script must be
NB. uppercase only. Plot does not use uppercase names in the
NB. code, therefore names defined here cannot conflict with it.
NB.
NB. verbs:
NB.   plotdefault    set default options
NB.   mydefault      more defaults
NB.
NB. nouns:
NB.   keywords
NB.   names for colors + color schemes

require 'colortab'
cocurrent 'jzplot'

NB. =========================================================
NB. define colors:
". toupper COLORTABLE

NB. =========================================================
NB. plotdefault
NB.   ASPECT         aspect ratio (for drawing, shrinks x direction)
NB.   AXES           if x, y axes shown
NB.   BACKCOLOR      background color
NB.   BANDCOLOR      band color
NB.   BORDERSIZE     bordersize for plotbox
NB.   BOXED          if boxed (3D only)
NB.   BORDER         if border
NB.   CAPTIONFONT    caption font (x,y,z captions)
NB.   CLEAR          if clear the background
NB.   EDGECOLOR      edge color (ellipse, pie, poly, rect)
NB.   ITEMCOLOR      item colors
NB.   FORECOLOR      foreground color
NB.   FRAME          if frame axis (2D only)
NB.   GRIDCOLOR      grid color
NB.   GRIDS          if x, y grids shown
NB.   KEY            key names
NB.   KEYFONT        key font
NB.   KEYSTYLE       key style (horiz/vert),(corner)
NB.   LABELFONT      label font
NB.   LABELS         if x, y labels shown
NB.   MESH           if mesh (3D only)
NB.   ORIENTATION    1=portrait, 2=landscape (printing only)
NB.   PENPATTERN     patterns used by pen styles
NB.   PENSIZE        pen size
NB.   PENSTYLE       pen styles (default 0)
NB.   PLOTBOX        plotbox
NB.   PLOTCAPTION       plot name
NB.   POLAR          if polar data (r;theta) (2D only)
NB.   RTIC           radar tic (style)
NB.   SEPARATOR      separator for char matrix entries
NB.   SYMBOLFONT     symbol font
NB.   SYMBOLS        symbol characters (e.g. point plots)
NB.   TEXTCOLOR      text color
NB.   TEXTFONT       text font
NB.   TICMAJOR       size of major tics (y direction)
NB.   TICMINOR       size of minor tics (y direction)
NB.   TICS           if x, y tics shown
NB.   TITLE          plot title
NB.   TITLEFONT      title font
NB.   TYPE           plot type
NB.   VIEWCENTER     xyz coordinates of plot center
NB.   VIEWPOINT      xyz coordinates of viewpoint
NB.   VIEWSIZE       xyz size of viewbox
NB.   VIEWUP         xyz direction of upwards
NB.   VISIBLE        if visible
NB.   XCAPTION       x axis caption
NB.   XGRIDPATTERN   x grid pattern
NB.   XINT           x intercept
NB.   XLABEL         x labels
NB.   XLOG           use log(x)
NB.   XRANGE         x range
NB.   XTIC           x tic (style)
NB.   XTICPOS        x tic positions
NB.   YCAPTION       y axis caption
NB.   YGRIDPATTERN   y grid pattern
NB.   YINT           y intercept
NB.   YLABEL         y labels
NB.   YLOG           use log(y)
NB.   YRANGE         y range
NB.   YTIC           y tic (style)
NB.   YTICPOS        y tic positions
NB.   ZGRIDPATTERN   z grid pattern
NB.   ZINT           z intercept
NB.   ZLABEL         z labels
NB.   ZLOG           use log(z)
NB.   ZRANGE         z range
NB.   ZTIC           z tic (style)
NB.   ZTICPOS        z tic positions

plotdefault=: 3 : 0
ASPECT=: 2%3
AXES=: 1
BACKCOLOR=: WHITE
BANDCOLOR=: RGCLR
BORDERSIZE=: 8
BORDER=: 0
BOXED=: 1
CAPTIONFONT=: 'Arial 25'
CLEAR=: 1
EDGECOLOR=: BLACK
ITEMCOLOR=: STDCLR
FORECOLOR=: BLACK
FRAME=: 0
GRIDCOLOR=: GRAY
GRIDS=: 0
KEY=: ''
KEYFONT=: '"Courier New" 25'
KEYSTYLE=: 0 2
LABELFONT=: '"Courier New" 25'
LABELS=: 1
MESH=: 1
ORIENTATION=: 2
PENSIZE=: 1
PENSTYLE=: 0
PENPATTERN=: 1 0;12 6;2 4;12 6 2 4;12 6 2 4 2 4
PLOTCAPTION=: 'Plot'
PLOTBOX=: 0 0 1000 1000
POLAR=: 0
SEPARATOR=: '|'
RTIC=: ''
SYMBOLFONT=: 'Symbol 25 bold'
SYMBOLS=: 183 180 43 42 {a.
TEXTCOLOR=: BLACK
TEXTFONT=: 'Arial 25'
TICMAJOR=: 12
TICMINOR=: 6
TICS=: 1
TITLE=: ''
TITLEFONT=: 'Arial 40'
TYPE=: 'line'
VIEWCENTER=: 0 0 0
VIEWPOINT=: 1.3 _2.4 2
VIEWPOINT=: 1.6 _2.4 1.5
VIEWSIZE=: 1 1 0.5
VIEWUP=: 0 0 1
VISIBLE=: 1
XCAPTION=: ''
XGRIDPATTERN=: 3 5
XINT=: ''
XLABEL=: ''
XLOG=: 0
XRANGE=: ''
XTIC=: ''
XTICPOS=: ''
YCAPTION=: ''
YGRIDPATTERN=: 3 5
YINT=: ''
YLABEL=: ''
YLOG=: 0
YRANGE=: ''
YTIC=: ''
YTICPOS=: ''
ZGRIDPATTERN=: 3 5
ZINT=: ''
ZLABEL=: ''
ZLOG=: 0
ZRANGE=: ''
ZTIC=: ''
ZTICPOS=: ''
mydefault''
)

NB. =========================================================
NB. use for temporary changes
mydefault=: 3 : 0
NB. BACKCOLOR=: GRAY
''
)

NB. =========================================================
NB. keywords
NB.
NB. KEYWORDS is a boxed list of lowercase keywords. A keyword
NB. given in the left argument to plot or as an argument to pd,
NB. is replaced with its uppercase definition.

NOAXES=: 'axes 0;boxed 0;labels 0;tics 0;'
KEYWORDS=: <'noaxes'

NB. =========================================================
NB. standard colors
STDCLR=: TEAL,BROWN,PURPLE,DARKRED,DARKBLUE,DARKGREEN,RED,BLUE,GREEN,YELLOW,FUCHSIA,:AQUA

NB. =========================================================
NB. RBCLR - red/blue color scheme for 3D surface plots:
RBCLR=: |. ". ;._2 (0 : 0)
255 0 0
255 0 16
255 0 32
240 0 32
224 0 32
224 0 48
224 0 64
208 0 64
192 0 64
192 0 80
192 0 96
176 0 96
160 0 96
160 0 112
160 0 128
)

NB. use following for 256 or fewer color display:
t=. |. ". ;._2 (0 : 0)
255 0 0
255 0 32
224 0 32
224 0 64
192 0 64
192 0 96
160 0 96
160 0 128
)

NB. =========================================================
NB. RGCLR - default red/green color scheme for 3D surface plots:
RGCLR=: |. ". ;._2 (0 : 0)
255 0 0
224 32 0
192 64 0
160 96 0
128 128 0
96 160 0
64 192 0
32 192 32
0 192 64
0 160 96
0 128 128
)

NB. =========================================================
NB. RGBCLR - red/green/blue color scheme for 3D surface plots:
RGBCLR=: |. ". ;._2 (0 : 0)
255   0    0
255 128    0
255 255    0
128 255  128
 0  196  196
  0 196  255
  0 128  255
  0  64  255
  0   0  255
)

NB. =========================================================
NB. BGCLR - blue/green color scheme for 3D surface plots:
BGCLR=: |. ". ;._2 (0 : 0)
64 64 255
64 80 240
64 96 224
64 112 208
64 128 192
64 144 176
64 160 160
64 176 144
64 192 128
64 208 112
64 224 96
64 240 80
)

NB. =========================================================
NB. gray scalepos colors
GRAYSCALE=: 1 (3&#)\ 255 <. 16*i.17
