NB. winsock package
NB. built from project: ~Api\socket\socket

script_z_ '~system\main\dll.ijs'
script_z_ '~system\main\libpath.ijs'

coclass 'jsocket'


jsystemdefs 'hostdefs'
jsystemdefs 'netdefs'

coinsert 'jdefs'
COCLASSPATH=: ;: 'jsocket jdefs z'

NB. util

res=: >@:{.
taketo=: [: ] (E. i. 1:) {. ]
deb=: #~ (+. (1: |. (> </\)))@(' '&~:)

NB. =========================================================
NB. fdset_bytes		compute the fds_bits byte array marking from a vector
NB.			with file descriptors to be marked.
NB.
NB. Output is a character (byte) vector.  The length of this result
NB. vector is given by x. and must be
NB. - a multiple of the word size (4).
NB. - large enough to accomodate all elements
NB. - not larger than FD_SETSIZE/8
NB. The monad defaults x. to the smallest such value.
NB.
NB. y. is a list of the interesting file descriptors ("small ints").

fdset_bytes=: 3 : 0
max=. >./ y.
'cannot represent fds within FD_SETSIZE limit' assert max<FD_SETSIZE
len=. 4 * <. 32 %~ max+31
len fdset_bytes y.
:
len=. x.
fds=. y.
bitvector=. 1 fds} (len*8)#0
bytes=. a. {~ _8 #.@|.\ bitvector
NB. Dependending on the platform endiness, the bytes within the words
NB. need to be reversed:
if. -. 1 0 0 0 -: a. i. 2 ic 1 do.
  bytes=. , _4 |.\ bytes
end.
bytes
)

NB. =========================================================
NB. fdset_fds	compute the list of file descriptors from
NB.		the fd_set byte array representation.
NB. Input y. is the byte array (as for example, filled by select(2)).
fdset_fds=: 3 : 0
bytes=. y.
NB. Dependending on the platform endiness, the bytes within the words
NB. need to be reversed:
if. -. 1 0 0 0 -: a. i. 2 ic 1 do.
  bytes=. , _4 |.\ bytes
end.
bitvec=. , _8 |.\ , (8#2)&#: a. i. bytes
fds=. (# i.@#) bitvec
)


NB. socket API calls

NB. =========================================================
NB. build adverbs
3 : 0''
select. UNAME
case. 'Win32' do.
  c=. >IFWINCE{'wsock32';'winsock'
  ccdm=: 1 : ('(''"',c,,'" '',x.)&(15!:0)')
  ncdm=: ccdm
  scdm=: ccdm
  wcdm=: ccdm
  LIB=: ''
case. 'Linux';'Darwin' do.
  c=. find_dll 'c'
  ccdm=: 1 : ('(''"',c,'" '',x.)&(15!:0)')
  ncdm=: ccdm
  scdm=: ccdm
  wcdm=: 1 : ']'
  LIB=: c
case. 'SunOS' do.
  c=. find_dll 'c'
  ccdm=: 1 : ('(''"',c,'" '',x.)&(15!:0)')
  n=. find_dll 'nsl'
  ncdm=: 1 : ('(''"',n,'" '',x.)&(15!:0)')
  s=. find_dll 'socket'
  scdm=: 1 : ('(''"',s,'" '',x.)&(15!:0)')
  wcdm=: 1 : ']'
  LIB=: c
end.
empty''
)

NB. =========================================================
NB. system specific definitions:
3 : 0''
select. UNAME
case. 'Win32' do.
  closesocketJ=: 'closesocket i i' scdm
case. 'Linux';'SunOS';'Darwin' do.
  closesocketJ=: 'close i i' scdm
end.
empty''
)

NB. ---------------------------------------------------------
gethostbyaddrJ=: 'gethostbyaddr * * i i' ncdm
gethostbynameJ=: 'gethostbyname * *c' ncdm
gethostnameJ=: 'gethostname i *c i' ncdm
inet_addrJ=: 'inet_addr i *c' ncdm
inet_ntoaJ=: 'inet_ntoa i i' ncdm

NB. ---------------------------------------------------------
acceptJ=: 'accept i i * *i' scdm
acceptNullJ=: 'acceptNull i i *c *c' scdm
bindJ=: 'bind i i * i' scdm
connectJ=: 'connect i i * i' scdm
FD_ISSETJ=: 'FD_ISSET i i ' scdm
getpeernameJ=: 'getpeername i i * *i' scdm
getprotobynameJ=: 'getprotobyname i *c' scdm
getprotobynumberJ=: 'getprotobynumber i i' scdm
getservbynameJ=: 'getservbyname i i i' scdm
getservbyportJ=: 'getservbyport i i i' scdm
getsocknameJ=: 'getsockname i i * *i' scdm
getsockoptJ=: 'getsockopt i i i i * *i' scdm
htonlJ=: 'htonl i i' scdm
htonsJ=: 'htons s s' scdm
ioctlsocketJ=: 'ioctlsocket i i i i' scdm
listenJ=: 'listen i i i' scdm
ntohlJ=: 'ntohl i i' scdm
ntohsJ=: 'ntohs s s' scdm
recvJ=: 'recv i i * i i' scdm
recvfromJ=: 'recvfrom i i *c i i * *i' scdm
selectJ=: 'select i i * * * *' ccdm
sendJ=: 'send i i *c i i' scdm
sendtoJ=: 'sendto i i *c i i * i' scdm
setsockoptJ=: 'setsockopt i i i i * i' scdm
shutdownJ=: 'shutdown i i i' scdm
socketJ=: 'socket i i i i' scdm

WSAAsyncGetHostByAddrJ=: 'WSAAsyncGetHostByAddr i i i i i i i i' wcdm
WSAAsyncGetHostByNameJ=: 'WSAAsyncGetHostByName i i i *c i i' wcdm
WSAAsyncGetProtoByNameJ=: 'WSAAsyncGetProtoByName i i i *c i i' wcdm
WSAAsyncGetProtoByNumberJ=: 'WSAAsyncGetProtoByNumber i i i i i i' wcdm
WSAAsyncGetServByNameJ=: 'WSAAsyncGetServByName i i i *c *c i i' wcdm
WSAAsyncGetServByPortJ=: 'WSAAsyncGetServByPort i i i i *c i i' wcdm
WSAAsyncSelectJ=: 'WSAAsyncSelect i i i i i' wcdm
WSACancelAsyncRequestJ=: 'WSACancelAsyncRequest i i' wcdm
WSACancelBlockingCallJ=: 'WSACancelBlockingCall i ' wcdm
WSACleanupJ=: 'WSACleanup i ' wcdm
WSAGetLastErrorJ=: 'WSAGetLastError i ' wcdm
WSAIsBlockingJ=: 'WSAIsBlocking i ' wcdm
WSASetBlockingHookJ=: 'WSASetBlockingHook i i' wcdm
WSASetLastErrorJ=: 'WSASetLastError i i' wcdm
WSAStartupJ=: 'WSAStartup i i i' wcdm
WSAStringToAddressJ=: 'WSAStringToAddress i c i i i i' wcdm
WSAUnhookBlockingHookJ=: 'WSAUnhookBlockingHook i ' wcdm
x_WSAFDIsSetJ=: 'x_WSAFDIsSet i i i' wcdm



NB. =========================================================
sderror=: 3 : 0
'num msg'=. SDERRORS
> (num i. >{.y.) { msg, <'unknown error'
)

NB. =========================================================
NB. define SDERRORS
j=. <;._2 (0 : 0)
    0 no error
10004 EINTR
10009 EBADF
10013 EACCES
10014 EFAULT
10022 EINVAL
10024 EMFILE
10035 EWOULDBLOCK
10036 EINPROGRESS
10037 EALREADY
10038 ENOTSOCK
10039 EDESTADDRREQ
10040 EMSGSIZE
10041 EPROTOTYPE
10042 ENOPROTOOPT
10043 EPROTONOSUPPORT
10044 ESOCKTNOSUPPORT
10045 EOPNOTSUPP
10046 EPFNOSUPPORT
10047 EAFNOSUPPORT
10048 EADDRINUSE
10049 EADDRNOTAVAIL
10050 ENETDOWN
10051 ENETUNREACH
10052 ENETRESET
10053 ECONNABORTED
10054 ECONNRESET
10055 ENOBUFS
10056 EISCONN
10057 ENOTCONN
10058 ESHUTDOWN
10059 ETOOMANYREFS
10060 ETIMEDOUT
10061 ECONNREFUSED
10062 ELOOP
10063 ENAMETOOLONG
10064 EHOSTDOWN
10065 EHOSTUNREACH
10066 ENOTEMPTY
10067 EPROCLIM
10068 EUSERS
10069 EDQUOT
10070 ESTALE
10071 EREMOTE
10091 SYSNOTREADY
10092 VERNOTSUPPORTED
10093 NOTINITIALISED
10101 EDISCON
11001 HOST_NOT_FOUND
11002 TRY_AGAIN
11003 NO_RECOVERY
11004 NO_DATA
)

SDERRORS=: (0 ". 5 {. &> j) ; < 6 }.each j

3 : 0''
if. IFUNIX do.
  SDERRORS=: (10000 | >{.SDERRORS);{:SDERRORS
end.
)



NB. sock main

flip=: 3 : '(256=0 ic 0 1{a.)|.y.'
getport=: 3 : '0 ic flip memr y.,sin_port_off,sin_port_sz,JCHAR'
j2i_sz=: 1 : '[:`({&a.)`(1&ic)`[:`(2&ic)@.x.'
i2j_sz=: 1 : '[:`(a.&i.)`(_1&ic)`[:`(_2&ic)@.x.'

NB. =========================================================
NB. get IP address from addr_in structure
NB. y. - pointer to the structure
NB. This function preserves the network byte order.
address2string=: 3 : 0
}: ;'.',~each ":each a.i. memr y.,0,4
)

NB. =========================================================
NB.*sdsockaddress v returns address
NB. y. active socket
sdsockaddress=: 3 : 0"0
if. IFUNIX do.
  sockin=. mema sockaddr_in_sz		NB. XXX IPv4 only
  if. 0 = res ret=. getsocknameJ y.;(<sockin);,sockaddr_in_sz do.
    'unexpected sock addr length' assert sockaddr_in_sz = {. 3 pick ret
    addr=. address2string sockin+sin_addr_off
  else.
    memf sockin
    _1;''
    return.
  end.
else.
NB.   adr=. mema 4
NB.   (2 ic 16) memw adr,0,4
  sockin=. mema 16
  if. 0 = res getsocknameJ y.;(<sockin);,16 do.
NB.     adr=. _2 ic memr sockin,0,4
NB.     addr=. address2string adr
    addr=. address2string sockin+4
  else.
    memf sockin
    _1;''
    return.
  end.
end.
memf sockin
0;addr
)

NB. =========================================================
NB.*sdsend v send data
NB. y.- socket;An indicator specifying the way in which the call is made (0)
NB. x.- data
sdsend=: 4 : 0"1
's indicator'=. y.
data=. x.
r=. sendJ s;data;(#data);indicator
if. _1 = >{.r do.
  r=. (sdsockerror '');0
else.
  r=. 0;{.r
end.
r
)

NB. =========================================================
NB.*sdsendto v send data
NB. y.- socket ; flags ; family ; address ; port
NB. x.- data
sdsendto=: 4 : 0"1
's flags family address port'=. y.
data=. x.

if. IFUNIX do.
  sockaddr=. mema sockaddr_in_sz		NB. XXX IPv4 specific
  
  (sin_family_sz j2i_sz fam) memw sockaddr_in, sin_family_off, sin_family_sz, JCHAR
  
  port=. res htonsJ port
  (1 ic port) memw sockaddr_in, sin_port_off, sin_port_sz, JCHAR
  
  addr=. a.{~".each '.' cutopen address	NB. preserving network byte order
  in_addr=. sockaddr_in+sin_addr_off
  addr memw in_addr, s_addr_off, s_addr_sz, JCHAR
  
  r=. sendtoJ s;data;(#data);flags;(<sockaddr_in);sockaddr_in_sz
  memf sockaddr_in
  
else.
  adr=. mema 4
  addr=. a.{~".each '.' cutopen address
  addr memw adr,0,4
  
  sock=. mema 16
  ((1 ic family,port),addr,8#0{a.)memw sock,0,16
  
  r=. sendtoJ s;data;(#data);flags;(<sock);16
  memf each adr,sock
end.
if. _1={.r do.
  r=. (sdsockerror '');0
else.
  r=. 0;{.r
end.
r
)

NB. =========================================================
NB.*sdcleanup v initialize winsock
sdcleanup=: 3 : 0
if. -. IFUNIX do.
  if. _1=nc <'WINSOCK' do.
    WINSOCK=: mema 400
NB. 257=&H101 i.e. version 1.1
    if. 0~: j=. res WSAStartupJ 257;WINSOCK do.
      WSACleanupJ ''
      wdinfo'Socket Error'
      memf WINSOCK
      _1
      return.
    end.
  end.
end.
if. 0 = nc <'SOCKETS' do.
  sdclose SOCKETS
end.
SOCKETS=: $0
0
)

sdreset=: sdcleanup

NB. =========================================================
NB.*sdinit v initialize winsock
sdinit=: 3 : 0
if. 0 ~: nc <'SOCKETS' do.
  sdreset''
end.
)

NB. =========================================================
NB.*sdrecv v read data
NB. y.- socket,data_size,An indicator specifying the way in which the call is made (0)
sdrecv=: 3 : 0"1
's size'=. 2 {. y.
buff=. mema size
if. SOCKET_ERROR~:res dat=. recvJ s;(<buff);size;2{3{.y. do.
  if. 0=l=. >{.dat do. 0;'' else. 0;memr buff,0,l end.
else. (sdsockerror '');'' end.
if. memf buff do. end.
)

NB. =========================================================
NB.*sdrecvfrom v read data from
NB. y.- socket,data_size,An indicator specifying the way in which the call is made (0)
sdrecvfrom=: 3 : 0"1
's size flags'=. 3 {. y. ,<0

if. IFUNIX do.
  sockaddr=. mema sockaddr_in_sz
  
  dat=. recvfromJ s;(size#'.');size;flags;(<sockaddr);,sockaddr_in_sz
  if. SOCKET_ERROR = rcvd_size=. res dat do.
    memf sockaddr
    (sdsockerror '');'';''
    return.
  end.
  
NB. There used to be a check here on the 0-length of the read data.
NB. However, nothing precludes a zero-length packet, in particular
NB. if an option preserving message bounderies should be set.
NB. The old code suppressed the source address in that case, we
NB. return it dutifully.   (It still does  not return the peer's
NB. port number, but that's just the way sdrecvfrom is designed.)
NB. The old was also erroneous in that it assumed that requested
NB. size would equal the received size.  They may differ.
  
  'unexpected size of peer address' assert sockaddr_in_sz = 6 pick dat
  dat=. rcvd_size {. 2 pick dat
  adr=. address2string sockaddr+sin_addr_off
  memf sockaddr
  
else.
  buff=. mema size
  sock=. mema 16
  len=. mema 4
  16 memw len,0,1,4
  
  if. SOCKET_ERROR~:res dat=. recvfromJ s;buff;size;flags;(<sock);,len do.
    if. 0={.;dat do.
      memf each buff,sock,len
      0;'';''
      return.
    else.
      dat=. memr buff,0,size
      adr=. address2string sock+4
    end.
  else.
    memf each buff,sock,len
    (sdsockerror '');'';''
    return.
  end.
  memf each buff,sock,len
end.
0;dat;adr
)


NB. =========================================================
NB.*sdconnect v connect to the socket
NB. y. - socket , family , address , port

sdconnect=: 3 : 0"1
's fam host port'=. >each y.
if. IFUNIX do.
  sockaddr_in=. mema sockaddr_in_sz
  
  (sin_family_sz j2i_sz fam) memw sockaddr_in, sin_family_off, sin_family_sz, JCHAR
  
  port=. res htonsJ port
  (1 ic port) memw sockaddr_in, sin_port_off, sin_port_sz, JCHAR
  
  addr=. a.{~".each '.' cutopen host	NB. preserving network byte order
  in_addr=. sockaddr_in+sin_addr_off
  addr memw in_addr, s_addr_off, s_addr_sz, JCHAR
  
  if. 0~:z=. res connectJ s;(<sockaddr_in);sockaddr_in_sz
  do. z=. sdsockerror '' end.
  memf sockaddr_in
  
else.
  port=. res htonsJ port
  if. port = INVALID_SOCKET do.
    INVALID_SOCKET
    return.
  end.
  
  adr=. mema 4
  addr=. a.{~".each '.' cutopen host
  addr memw adr,0,4
  
  sock=. mema 16
  ((1 ic fam,port),addr,8#0{a.)memw sock,0,16
  
  if. 0~:z=. res connectJ s;(<sock);16 do. z=. sdsockerror '' end.
  memf each adr,sock
end.
z
)

NB. =========================================================
NB.*sdsocket v creates a socket
sdsocket=: 3 : 0"1
s=. y.
if. 0=#y. do.
  s=. PF_INET,SOCK_STREAM,IPPROTO_TCP
end.
s=. 3 {. s
s=. res socketJ (0{s);(1{s);2{s
if. s = _1 do.
  (sdsockerror '');0
  return.
end.
SOCKETS=: SOCKETS,s
0;s
)


NB. =========================================================
NB.*sdbind v bind socket
NB. y. - socket , family , address , port

sdbind=: 3 : 0"1
's fam host port'=. >each y.
if. IFUNIX do.
  sockaddr_in=. mema sockaddr_in_sz
  
  (sin_family_sz j2i_sz fam) memw sockaddr_in, sin_family_off, sin_family_sz, JCHAR
  
  port=. res htonsJ port
  (1 ic port) memw sockaddr_in, sin_port_off, sin_port_sz, JCHAR
  
  if. 0=#addr=. a.{~".each '.' cutopen host do.
    addr=. 2 ic res htonlJ INADDR_ANY
  end.
  in_addr=. sockaddr_in+sin_addr_off
  addr memw in_addr, s_addr_off, s_addr_sz, JCHAR
  
  if. 0 ~: res bindJ s;(<sockaddr_in);sockaddr_in_sz do.
    z=. sdsockerror ''
    if. s ~: _1 do.
      dummy=. sdclose {.s
    end.
    memf sockaddr_in
    z return.
  end.
  memf sockaddr_in
else.
  port=. res htonsJ port
  if. port = INVALID_SOCKET do.
    INVALID_SOCKET
    return.
  end.
  
  adr=. mema 4
  if. 0=#addr=. a.{~".each '.' cutopen host do.
NB. no address provided
    addr=. 4#0{a.
  end.
  addr memw adr,0,4
  
  sock=. mema 16
  ((1 ic fam,port),addr,8#0{a.)memw sock,0,16
  
  if. 0~:res bindJ s;(<sock);16 do.
    z=. sdsockerror ''
    if. s ~: _1 do.
      dummy=. sdclose {.s
    end.
    memf each adr,sock
    z return.
  end.
  memf each adr,sock
end.
0
)

NB. =========================================================
NB.*sdasync v set up async connection for the socket
sdasync=: 3 : 0"0
if. IFUNIX do.
  'not implemented under Unix/Linux - please use sdselect' assert 0
else.
  flags=. OR/ FD_READ,FD_WRITE,FD_OOB,FD_ACCEPT,FD_CONNECT,FD_CLOSE
  hwnd=. ".wd'qhwndx'
  if. >{.WSAAsyncSelectJ ({.y.);hwnd;1026;flags do. sdsockerror '' else. 0
  end.
end.
)


NB. =========================================================
NB.*sdlisten v set up listener for the socket
NB. y. - socket;queue_length
NB. SOMAXCONN - The maximum length of the queue of pending connections
sdlisten=: 3 : 0"1
's l'=. 2 {. y.,<^:(L.y.) SOMAXCONN
if. 0=res listenJ s;l do.
  0
else.
  sdsockerror ''
end.
)


NB. =========================================================
NB.*sdaccept v accept connection
NB. y. - socket

sdaccept=: 3 : 0"0
if. IFUNIX do.
  sockin=. mema sockaddr_in_sz
  if. _1 ~: s=. res r=. acceptJ y.;(<sockin);,sockaddr_in_sz do.
    'unexpected peer address size' assert sockaddr_in_sz = >3{r
    SOCKETS=: SOCKETS,s
    0;s
  else.
    (sdsockerror '');0
  end.
  if. memf sockin do. end.
else.
  d=. 16
  sockin=. mema 16
  if. _1 ~: s=. res acceptJ y.;(<sockin);,d do.
    SOCKETS=: SOCKETS,s
    0;s
  else.
    (sdsockerror '');0
  end.
  if. memf sockin do. end.
end.
)

NB. =========================================================
NB.*sdgethostbyname v returns an address from a name
NB. y. - host name
sdgethostbyname=: 3 : 0
if. IFUNIX do.
  if. _1=res addr=. inet_addrJ <y. do.
    if. 0~: hostent=. res gethostbynameJ <y. do.
      addr_list=. memr hostent, h_addr_list_off, 1, JPTR
      first_addr=. memr addr_list, 0, 1, JPTR
      'name did not resolve to address' assert first_addr ~: 0
      addr=. address2string first_addr
    else.
      addr=. '255.255.255.255'
    end.
  else.
    addr=. }: ;'.',~each ":each a.i.>1{addr
  end.
else.
  if. _1=res addr=. inet_addrJ <y. do.
    if. 0~:adr=. res gethostbynameJ <y. do.
      adr1=. _2 ic memr adr, 12, 4
      hadr=. _2 ic memr adr1,0,4
      addr=. address2string hadr
    else.
      addr=. '255.255.255.255'
    end.
  else.
    addr=. }: ;'.',~each ":each a. i. 2 ic >0{addr
  end.
end.
0;PF_INET;addr
)

NB. =========================================================
NB.*sdgethostbyaddr v returns a name from an address
NB. y. - AF_INET;host ip address

sdgethostbyaddr=: 3 : 0"1
'fam addr'=. y.
try.
  addr=. a.{~".each '.' cutopen ;addr
catch.
  _1;'unknown host'
  return.
end.

if. IFUNIX do.
  in_addr=. mema in_addr_sz
  addr memw in_addr,0,in_addr_sz,JCHAR  NB. aligned address in network byte order
  
  host_ent=. res gethostbyaddrJ (<in_addr); in_addr_sz ;fam
  if. host_ent ~:0 do.
    h_name=. memr, host_ent, h_name_off, 1, JPTR
    name=. memr h_name, 0, JSTR
  else.
    memf in_addr
    _1;'unknown host'
    return.
  end.
  memf in_addr
else.
  ad=. mema 4
  addr memw ad,0,4
  phe=. res gethostbyaddrJ (<ad);4;fam
  if. phe~:0 do.
    adr=. _2 ic memr phe,0,4
    name=. memr adr,0,256
    name=. >1 take (0{a.)cutopen name
  else.
    memf ad
    _1;'unknown host'
    return.
  end.
  memf ad
end.
0;name
)

NB. =========================================================
NB.*sdclose v close socket
NB. y. - socket
sdclose=: 3 : 0"0
if. 0=res closesocketJ <y. do.
  SOCKETS=: SOCKETS-.y.
  0
else.
  sdsockerror ''
end.
)


NB. =========================================================
NB.*sdselect v find sockets that need work
sdselect=: 3 : 0
if. IFUNIX do.
  if. 0=#y. do.
    'r w e t'=. SOCKETS;SOCKETS;SOCKETS;0
  else.
    'r w e t'=. y.
  end.
  
  nul=. i.0
  bytes=. 4*words=. >:<.32%~len=. >:>./r,w,e,0
  
  fdsetr=. mema bytes
  (bytes fdset_bytes r) memw fdsetr,fds_bits_off,bytes,JCHAR
  fdsetw=. mema bytes
  (bytes fdset_bytes w) memw fdsetw,fds_bits_off,bytes,JCHAR
  fdsete=. mema bytes
  (bytes fdset_bytes e) memw fdsete,fds_bits_off,bytes,JCHAR
  
  time=. mema timeval_sz
NB. t is in milliseconds;  convert this into seconds and _micro_seconds:
  ( <.t % 1000) memw time,tv_sec_off, 1,JINT
  (1000 * <.t |~1000) memw time,tv_usec_off,1,JINT
  
  if. _1=>{.selectJ len;(<fdsetr);(<fdsetw);(<fdsete);<<time do.
    memf"0 fdsetr,fdsetw,fdsete,time
    (sdsockerror '');nul;nul;nul
    return.
  end.
  
  r=. fdset_fds memr fdsetr,fds_bits_off,bytes,JCHAR
  w=. fdset_fds memr fdsetw,fds_bits_off,bytes,JCHAR
  e=. fdset_fds memr fdsete,fds_bits_off,bytes,JCHAR
  
  memf"0 time,(#~ *) fdsetr,fdsetw,fdsete
  
  0;r;w;e
else.
  
NB. If no arguments given, look at all sockets we have allocated
  y=. y.
  if. 0=#y do. y=. SOCKETS;SOCKETS;SOCKETS;0 end.
NB. Convert the millisecond timeout time to seconds/microseconds and save
  (<. 1000000 1000000 #: 1000 * 3{::y) memw (time=. mema 8),0 2 4
NB. verb to allocate an FD_SET if y is nonempty, 0 otherwise
  callo=. mema@((4+FD_SETSIZE*4)"_)^:] *@#
NB. verb to limit y. to the size of an FD_SET, and prepend the number of sockets
  fmtfdset=. (,~ #)@({.~ FD_SETSIZE&<.@#)
NB. Conditionally allocate storage for the read/write/error FD_SETs;
NB. trim the socket lists down to a maximum of FD_SETSIZE each
NB. (surplus is discarded); if the allocation is nonzero, copy
NB. the socket descriptors to the FD_SET (count followed by data).
NB. Keep the address of each allocation (or 0 for empty list)
  
  fdrwe=. (fmtfdset (] [ ([ memw ],0:,#@[,4:)^:(0:~:])) callo)@> 3{.y
  
NB. Call to check socket status
NB.  if. _1=res selectJ (<"0) 0,fdrwe,time do.
  if. _1=res selectJ 0 ; < each fdrwe, time do.
    
NB. Error - return socket error code
    (sdsockerror '');($0);($0);($0)
  else. NB. Good return...
NB. For each FD_SET that is nonzero, read the number of sockets
NB. returned, and then read that many socket numbers.  If the
NB. FD_SET is null, or if the number of sockets returned was 0,
NB. return an empty list.  Prepend good return code
    0; <@( i.@]`([: memr [,4:,],4:)@.(0:~:]) ({.@memr@(,&0 1 4))^:(0&~:) )"0 fdrwe
  end.
NB. Free up all the memory we allocated, but leave result unchanged
  if. memf"0 (time, fdrwe) -. 0 do. end.
end.
)

NB. =========================================================
NB. Returns the value of a socket option.
sdgetsockopt=: 3 : 0

's lev name'=. y.
buf=. mema 4
len=. mema 4
4 memw len,0,1,JINT
r=. getsockoptJ s;lev;name;(<buf);<<len
if. 0=>{.r do.
  if. name-:SO_LINGER do.
    r=. _1 ic memr buf,0,(memr len,0,1,JINT), JCHAR
  else.
    r=. _2 ic memr buf,0,(memr len,0,1,JINT), JCHAR
  end.
  memf each buf,len
  0;r
  return.
end.
memf each buf, len
(sdsockerror '');0
)


NB. =========================================================
NB.*sdsetsockopt v sets the value of a socket option.

sdsetsockopt=: 3 : 0
's lev name'=. 3{.y.
NB. XXX The following assumes that the only option type is
NB. int (short int).  This is not valid.  The fixed length
NB. is buggy in the same way.
val=. 3}.y.
if. name -: SO_LINGER do.
  val=. ,/1 ic each 2{.val  NB. 2 short integers
else.
  val=. 2 ic >val
end.

buf=. mema 4
val memw buf,0,4
len=. 4
r=. setsockoptJ s;lev;name;(<buf);len
if. 0=>{.r do.
  r=. _2 ic memr buf,0,len
  memf buf
  0;r
  return.
end.
memf buf
(sdsockerror '');0
)

NB. =========================================================
NB.*sdsockerror v retrieve socket error code
sdsockerror=: 3 : 0
> {. cderx ''
)

NB. =========================================================
NB.*sdioctl v read or write socket control information
sdioctl=: 3 : 0
if. IFUNIX do.
NB. check if ioctl needs only the socket and FIONBIO:
  (LIB,' ioctl i i i') cd 2 {. <@> y.
else.
  's option value'=. y.
  adr=. mema 4
  value memw adr,0,1,4
  if. 0=res r=. ioctlsocketJ s;option;adr do.
    val=. memr adr,0,1,4
    memf adr
    0;val
  else.
    memf adr
    (sdsockerror '');0
  end.
end.
)

NB. =========================================================
NB.*sdionread v get number of bytes available for reading socket
sdionread=: 3 : 0
> {. sdcheck sdioctl y. , FIONREAD,0
)

NB. =========================================================
NB.*sdgethostname v returns host name
sdgethostname=: 3 : 0
if. 0=res name=. gethostnameJ (256#' ');256 do.
  name=. >{.1 take (0{a.)cutopen ;1{name
else.
  name=. 'unknown host'
end.
0;name
)


NB. =========================================================
NB.*sdgetpeername v returns address this socket is connected to
NB. y. active socket
sdgetpeername=: 3 : 0
if. IFUNIX do.
  sockin=. mema sockaddr_in_sz
  if. 0=ret=. res getpeernameJ y.;(<sockin);,sockaddr_in_sz do.
    fam=. AF_INET
    addr=. address2string sockin+sin_addr_off
    port=. >{. ntohsJ {. _1 ic memr sockin,sin_port_off,sin_port_sz,JCHAR
  else.
    fam=. 0
    addr=. ''
    port=. 0
  end.
  memf sockin
else.
  sockin=. mema 16
  if. 0=ret=. res getpeernameJ y.;(<sockin);,16 do.
    fam=. AF_INET
    addr=. }: ;'.',~each ":each a.i. memr sockin,4,4
    port=. >{. ntohsJ {._1 ic memr sockin,2,2
  else.
    fam=. 0
    addr=. ''
    port=. 0
  end.
NB.   memf each adr,sockin
  memf sockin
end.
ret;fam;addr;port
)

NB. =========================================================
NB.*sdgetsockname v returns address of this socket
NB. y. active socket
sdgetsockname=: 3 : 0"0
if. IFUNIX do.
  sockin=. mema sockaddr_in_sz
  if. 0=ret=. res getsocknameJ y.;(<sockin);,sockaddr_in_sz do.
    fam=. AF_INET
    addr=. address2string sockin+sin_addr_off
    port=. >{.ntohsJ {. _1 ic memr sockin,sin_port_off,sin_port_sz,JCHAR
  else.
    fam=. 0
    addr=. ''
    port=. 0
  end.
  memf each sockin
else.
  adr=. mema 4
  (2 ic 16)memw adr,0,4
  sockin=. mema 16
  if. 0=ret=. res getsocknameJ y.;(<sockin);<<adr do.
    fam=. AF_INET
    addr=. }: ;'.',~each ":each a.i. memr sockin,4,4
    port=. >{.ntohsJ {._1 ic memr sockin,2,2
  else.
    fam=. 0
    addr=. ''
    port=. 0
  end.
  memf each adr,sockin
end.
ret;fam;addr;port
)


NB. =========================================================
NB.*sdgetsockets v returns all socket numbers
sdgetsockets=: 3 : 0
try.
  r=. 0;SOCKETS
catch.
  r=. ,<0
end.
r
)

NB. =========================================================
NB.*sdcheck v check socket for errors
NB. socket utilities
sdcheck=: 3 : 0
if. 0 ~: >0{y. do.
  (sderror y.) 13!:8 [ 3
else.
  }. y.
end.
)



NB. winsock run

INVALID_SOCKET=: 1
SOCKET_ERROR=: _1
BUFFER_SIZE=: 1024

NB. =========================================================
sdinit''
