NB. component file definitions
NB. built from project: ~Packages\jfiles\jfiles
NB. J component file definitions


NB.*jcreate v create jfile, jcreate 'dat'
NB.*jappend v append to jfile, (<i.2 3) jappend 'dat'
NB.*jdup v duplicate jfile, 'new' jdup 'dat'
NB.*jerase v erase jfile, jerase 'dat'
NB.*jread v read jfile, jread 'dat';2
NB.*jreplace v replace in jfile, ('new value';123) jreplace 'dat';2 5
NB.*jsize v return size of jfile, jsize 'dat'

cocurrent 'z'

jappend=: jappend_jfiles_
jcreate=: jcreate_jfiles_
jdup=: jdup_jfiles_
jerase=: jerase_jfiles_
jread=: jread_jfiles_
jreplace=: jreplace_jfiles_
jsize=: jsize_jfiles_

NB. jfiles.ijs
NB.
NB. main functions:
NB.   jappend
NB.   jcreate
NB.   jdup
NB.   jerase
NB.   jread
NB.   jreplace
NB.   jsize
NB.
NB. other functions:
NB.   jopen
NB.   jclose
NB.   jseqno
NB.
NB. header structure:
NB.   [0]   v  version
NB.   [1]   s  starting component
NB.   [2]   c  number of components
NB.   [3]   l  file length
NB.   [4]   d  directory pointer
NB.   [5]   f  freelist pointer
NB.   [6]   q  sequence number
NB.
NB. error results:
NB.   _1   file not found
NB.   _2   invalid component
NB.   _3   invalid data
NB.   _4   host access error

coclass 'jfiles'

NB. =========================================================
NB. jappend      - append to file
jappend=: 4 : 0
'h o'=. j_open y.
if. h=_1 do. return. end.
'v s c l d f q'=. j_dir h
free=. j_read h;f
dat=. j_box x.
if. 1<#$dat do.
  if. o do. jclose h end.
  _3 return.
end.
res=. c+ i.#dat
'l free new'=. dat j_writerep l;free;h
dat=. j_tochar ,new
'b e'=. d
if. e>8*{:res do.
  dat 1!:12 h;b+8*c
  (j_rep free) 1!:12 h;{.f
else.
  dat=. (1!:11 h;b,8*c),dat
  free=. j_compress d,f,free
  'l free new'=. (<dat) j_write l;free;h
  'l f'=. j_writefree l;free;h
  d=. ,new
end.
c=. >:{:res
q=. >:{.q,0
(j_rep v;s;c;l;d;f;q) 1!:12 h;0
if. o do. jclose h end.
j_validate y.
res
)

NB. =========================================================
NB. jclose      - close file
jclose=: 1!:22 :: _4:

NB. =========================================================
NB. jcreate      - create file
NB. overwrites any existing file
NB. optional left argument is initial # of components
jcreate=: 3 : 0
0 jcreate y.
:
q=. s=. c=. 0
d=. 256,>.&.(2&^.) 512>.8*x.
f=. (+/d),256
l=. +/f
v=. 1718235185
hdr=. ({.f){.j_rep v;s;c;l;d;f;q;s
hdr=. l{.hdr,j_rep i.0 2
y=. <j_name y.
1!:55 :: 0: y
f=. (1: [ 1!:2) :: 0:
hdr f y
)

NB. =========================================================
NB. jdup         - duplicate file
NB.
NB. if specific components are to be duplicated, these are read
NB. and written one at a time, otherwise the file is duplicated
NB. in batches of up to the size <max> given in the function.
jdup=: 3 : 0
'' jdup y.
:

fl=. x.
'y sel'=. 2{.boxopen y.
y=. j_name y

max=. 100000

if. own=. 0=#fl do.
  fl=. ((+./\.y=PATHSEP_j_)#y),'eraseme.pls'
end.

'h o'=. j_open y
if. h=_1 do. return. end.

if. #sel do.
  (c=. #sel) jcreate fl
  hx=. jopen fl
  whilst. #sel=. }.sel do.
    (jread h;{.sel) jappend hx
  end.
  
else.
  'v s c l d f q'=. j_dir h
  c jcreate fl
  hx=. jopen fl
  pos=. 0
  blk=. 1000
  read=. j_read@(h&;)
  while. c > pos do.
    j=. (({.d)+8*pos),8*blk<.c-pos
    dir=. _2[\ j_tonum 1!:11 h;j
    pos=. pos+blk
    while. #dir do.
      siz=. {:"1 dir
      len=. 1>.(max<+/\siz)i.1
      (read &.> <"1 len{.dir) jappend hx
      dir=. len}.dir
    end.
  end.
  
end.

jclose hx
if. o do. jclose h end.

if. own do.
  pos=. 0
  siz=. 1!:4 <fl
  '' 1!:2 <y
  while. siz>pos do.
    len=. max<.siz-pos
    (1!:11 fl;pos,len) 1!:3 <y
    pos=. pos+max
  end.
  1!:55 <fl
end.

j_validate fl
c
)

NB. =========================================================
NB. jerase       - erase file
jerase=: 1!:55 @ < @: j_name

NB. =========================================================
NB. jopen        - open file
NB. returns handle or _1
jopen=: 3 : 0
y=. >y.
if. 0 e. #y do. _1 return. end.
if. 2=3!:0 y do.
  y=. <j_ext y
  1!:21 :: _1: y
end.
)

NB. =========================================================
NB. jread        - read file
jread=: 3 : 0
'y x'=. y.
'h o'=. j_open y
if. h=_1 do. return. end.
'v s c l d f q'=. j_dir h
cpt=. ,x
if. 1 e. (cpt<0) +. cpt>:c
do.
  if. o do. jclose h end.
  _2 return.
end.
dir=. h j_readdir &.> ({.d)+cpt*8
dat=. j_read@(h&;) &.> dir
if. o do. jclose h end.
($x)$dat
)

NB. =========================================================
NB. jreplace     - replace in file
jreplace=: 4 : 0
'y x'=. y.
'h o'=. j_open y
if. h=_1 do. return. end.
'v s c l d f q'=. j_dir h
free=. j_read h;f
cpt=. ,x
if. 0=#cpt do. return. end.
if. 1 e. (cpt<0) +. cpt>:c
do.
  if. o do. jclose h end.
  _2 return.
end.
dat=. j_box x.
if. 1<#$dat do.
  if. o do. jclose h end.
  _3 return.
end.
dat=. (#cpt)$dat
dir=. >h j_readdir &.> ({.d)+cpt*8
free=. j_compress dir,f,free
'l free new'=. dat j_writerep l;free;h
new=. _8 <\ j_tochar ,new
new (1!:12 h&;) &.> ({.d)+cpt*8
'l f'=. j_writefree l;free;h
q=. >:{.q,0
(j_rep v;s;c;l;d;f;q) 1!:12 h;0
if. o do. jclose h end.
j_validate >{.y.
cpt
)

NB. =========================================================
NB. jseqno
jseqno=: 3 : 0
'h o'=. j_open y.
if. h=_1 do. return. end.
q=. >6{j_dir h
if. o do. jclose h end.
q
)

NB. =========================================================
NB. jsize
jsize=: 3 : 0
'h o'=. j_open y.
if. h=_1 do. return. end.
'v s c l d f q'=. j_dir h
free=. j_read h;f
if. o do. jclose h end.
s,c,l,{:+/free
)

NB. =========================================================
NB. utilities

j_blk=: >.&.(2&^.)@#
j_box=: <^:(L. = 0:)
j_dir=: [: 7&{. [: 3!:2 [: 1!:11 ;&0 256
j_ext=: , #&'.ijf' @ (0: = '.'"_ e. ([: >./ # | i:&'/\') }. ])
j_nos=: [: ; [: {."1 (1!:20)
j_read=: 3!:2 @ (1!:11)
j_readdir=: j_tonum @ (1!:11) @ (; ,&8)
j_rep=: 3!:1
j_tonum=: _2&(3!:4)
j_tochar=: 2&(3!:4)
j_writerep=: j_rep&.>@[ j_write ]

NB. =========================================================
NB. j_compress  - compress free list
j_compress=: 3 : 0
bgn=. {."1 f=. /:~ y.
b=. bgn ~: _1|.+/"1 f
if. 0 e. b do.
  f=. (b#bgn) ,. b +/;.1 {:"1 f
end.
f /: {:"1 f
)

NB. =========================================================
NB. j_name
NB. returns file name (or handle if given)
j_name=: 3 : 0
y=. >y.
if. 2=3!:0 y do.
  y=. j_ext y
end.
)

NB. =========================================================
NB. j_open        - open file
NB. returns 2 elements: handle,ifopened  or  _1
j_open=: 3 : 0
y=. >y.
if. 0 e. #y do. _1 return. end.
if. 2=3!:0 y do.
  y=. j_ext y
  j=. 1!:11 :: _1: y;0 0
  if. _1 -: j do. return. end.
  n=. ;{."1 [ 1!:20''
  h=. 1!:21 <y
  h,-.h e. n
else.
  y,0
end.
)

NB. =========================================================
NB. j_validate
NB. checks directory + freelist
NB. use for testing only - set to ] in distributed system
j_validate=: 3 : 0
'h o'=. j_open y.
if. h=_1 do. return. end.
'v s c l d f q'=. j_dir h
free=. j_read h;f
dir=. _2[\ j_tonum 1!:11 h;({.d),8*c
r=. /:~ f,d,dir,free
y=. 256,+/"1 r
if. o do. jclose h end.
13!:8 [ 12 }.~ y -: ({."1 r),l
)

j_validate=: ]

NB. =========================================================
NB. j_write     - write data to file
NB. x. = data as boxed list
NB. y. = filelength;freelist;file
NB. result = filelength;freelist;position
j_write=: 4 : 0
'l f h'=. y.
x=. ,x.
d=. i.0 2

while. #x do.
  blk=. j_blk dat=. >{.x
  x=. }.x
  if.
    (#f) > ndx=. 1 i.~ blk <: {:"1 f
  do.
    'p s'=. ndx{f
    d=. d,p,blk
    if. blk < s do.
      f=. ((p+blk),s-blk) ndx } f
    else.
      f=. (ndx{.f),(>:ndx)}.f
    end.
    dat 1!:12 h;p
  else.
    d=. d,l,blk
    l=. l+blk
    (blk{.dat) 1!:3 h
  end.
end.

l;f;d
)

NB. =========================================================
NB. j_writefree   - write freelist to file
NB. y. = filelength;freelist;file
NB. result = filelength;position
j_writefree=: 3 : 0
'l f h'=. y.

blk=. 256 >. j_blk dat=. j_rep f
if.
  (#f) > ndx=. 1 i.~ blk <: {:"1 f
do.
  'p s'=. ndx{f
  d=. p,blk
  if. blk < s do.
    f=. ((p+blk),s-blk) ndx } f
  else.
    f=. (ndx{.f),(>:ndx)}.f
  end.
  (j_rep f) 1!:12 h;p
else.
  d=. l,blk
  l=. l+blk
  (blk{.dat) 1!:3 h
end.

l;d
)
