NB. built from project: ~Classes\graphics\gnuplot\gnuplot

coclass 'jgnuplot'


NB. gnuplot ini settings - modify as appropriate:
GNUPLOTINI=: 'c:\windows\gnuplot.ini'

NB. directory for gnuplot graphics files:
GNUPLOTDIR=: jpath '~temp'

NB. other globals:
SETBUFFER=: ''

NB. gnuplot utility functions
NB.
NB. loaded into gnuplot locale

NB. ========================================================
plot=: 3 : 0
'' plot y.
:
'' gnuplot x.;<y.
)

NB. ========================================================
splot=: 3 : 0
'' splot y.
:
's' gnuplot x.;<y.
)

NB. ========================================================
NB. gnuplot      - main 2D plotting function
gnuplot=: 4 : 0
'cmd dat'=. y.
dat=. gpmatrix &.> boxopen dat
fls=. (GNUPLOTDIR,'gnu')&,@(,&'.dat')@": &.>i.#dat
dat gpwrite&.> fls

txt=. gpsetcommand''
txt=. txt, x. gpcommand cmd;<fls
txt 1!:2 <GNUPLOTDIR,'gnu.plt'
)

NB. ========================================================
NB. gpcommand
NB. returns plot command
gpcommand=: 4 : 0
'cmd fls'=. y.
msk=. #~ -.@(+. ~:/\)@(e.&'''"')
fls=. ', "'&,@(,&'" ') &.> fls
cmd=. ' ',cmd
cmd=. <;._2 cmd, ',' #~ ',' ~: {: cmd

txt=. msk &.> cmd
if. '[' e. j=. >{.txt do.
  b=. +./\.j=']'
  range=. b#first=. >{.cmd
  cmd=. (<(-.b)#first),}.cmd
else. range=. ''
end.

b=. (1&e.) @ ('title'&E.) &> txt
NB. nonce, dont use notitle with splot (crashes gnuplot 3.4)
t=. ('s' e. x.){' notitle';' title ""'
cmd=. (b{t,<'') ,&.> cmd

cmd=. (#fls){.cmd,(#fls)#{:cmd
x.,'plot ',range, }.;fls ,&.> cmd
)

NB. ========================================================
gpflatten=: [:  _2&}. [: ; ,&CRLF@, &.> @ < @ (,"1&CRLF @ ":)"2

NB. ========================================================
NB. set
set=: 3 : 0
NB. build set arguments in SETBUFFER
NB. if y. is empty, return and reset buffer
r=. empty ''
if. #y. do.
  y=. y., ';' #~ ';' ~: {: y.   NB. ensure trailing ;
  SETBUFFER=: SETBUFFER,y
else.
  if. 0=4!:0 <'SETBUFFER' do. r=. SETBUFFER end.
  SETBUFFER=: ''
end.
r
)

NB. ========================================================
gpsetcommand=: 3 : 0
NB. ;< @ ('set '&, @ (,&CRLF)) ;._2 set''
;< @ ('set '&, @ (,&LF)) ;._2 set''
)

NB. ========================================================
gpmatrix=: ]`(,.~ i.@#) @. (2&>@#@$)

NB. ========================================================
NB. gpwrite   - write data to file as text
NB. dat gpwrite file
gpwrite=: 3 : 0
:
dat=. gpflatten x.
dat=. '-' ((#i.@#)dat='_') } dat
dat 1!:2 boxopen y.
)

NB. ========================================================
NB. global SETTINGS has possible gnuplot set names
SETTINGS=: 0 : 0
angles
arrow
autoscale
border
boxwidth
clabel
clip
cntrparam
contour
data style
dgrid3d
dummy
format
function style
functions
grid
hidden3d
isosamples
key
label
logscale
mapping
offsets
output
parametric
polar
rrange
samples
size
style
surface
terminal
tics
time
title
trange
urange
variables
view
vrange
xlabel
xrange
xtics
xdtics
xmtics
xzeroaxis
ylabel
yrange
ytics
ydtics
ymtics
yzeroaxis
zero
zeroaxis
zlabel
zrange
ztics
zdtics
zmtics
)

NB. ========================================================
NB. global STYLES has possible gnuplot styles
STYLES=: 0 : 0
boxes
boxerrorbars
dots
errorbars
impulses
lines
linespoints
points
steps
)


NB. supports gnuplot for Windows
NB.
NB. written with gnuplot 3.7

NB. cover functions defined in base locale:
plot=: plot_gnuplot_
splot=: splot_gnuplot_
set=: set_gnuplot_
